<?php
defined('BASEPATH') or exit('No direct script access allowed');
require APPPATH . '/libraries/REST_Controller.php';
class Api extends REST_Controller
{
    private $secret_key = 'Aimsoft';
    public function __construct()
    {
        parent::__construct();
        date_default_timezone_set('Asia/Kolkata');
        $this->load->model('Api_model');
        $this->load->model('User_model');
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->database();
        $this->load->library('email');
        $this->load->helper('string');
        $encrypted_token = $this->input->get_request_header('token');
        $authenticated = $this->verify_token($encrypted_token);
        if (!$authenticated) {
            $this->output
                ->set_content_type('application/json')
                ->set_status_header(401)
                ->set_output(json_encode(['error' => 'Unauthorized']));
            exit;
        }
    }
    public function register_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        $this->form_validation->set_rules('email', 'Email', 'required|valid_email|is_unique[users.email]');
        $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            $input_data = array(
                'first_name' => $this->input->post('first_name', true),
                'email' => $this->input->post('email', true),
                'password' => md5($this->input->post('password', true)),
                'status' => $status,
                'date_added' => $date_added,
                'date_updated' => $date_added,
            );
            $res = $this->User_model->insert($input_data);
            $insert_id = $this->db->insert_id();
            $query = $this->db->get_where('users', array('user_id' => $insert_id));
            $row = $query->row();
            if(!empty($this->input->post('language_id', true))){
                if ($res == true) {
                    $res = $this->Api_model->get_label_value('user_registered_successfully',$this->input->post('language_id', true));
                    $data['success_message'] = $res->label_element_value;
                } else {
                    $res = $this->Api_model->get_label_value('unable_to_register_please_try_again',$this->input->post('language_id', true));
                    $data['error_message'] = $res->label_element_value;
                }
            }
            else{
                if ($res == true) {
                    $data['success_message'] = 'User registered successfully';
                } else {
                    $data['error_message'] = 'Unable to register, Please try again';
                }
            }
            

            if (isset($row->dob) && !empty($row->dob)) {
                $dob = $row->dob;
            } else {
                $dob = '';
            }

            $responseData = array(
                'status' => 'success',
                'message' => $data['success_message'],
                'userInfo' => array(
                    'user_id' => $row->user_id,
                    'first_name' => $row->first_name,
                    'email' => $row->email,
                    'phone' => $row->phone,
                    'status' => $row->status,
                    'date_added' => $row->date_added,
                    'date_updated' => $row->date_updated,
                ),
            );
            return $this->response($responseData, 200);
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }
    public function social_login_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        // $this->form_validation->set_rules('email', 'Email', 'required|valid_email|is_unique[users.email]');
        // $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            if ( null !== $this->input->post('email') && !empty($this->input->post('email'))) {
                $data = array('email' => $this->input->post('email'), 'status' => 1);
                $loginStatus = $this->Api_model->checkLogin($data);
                if ($loginStatus != false) {
                    $patientDate = [
                        'user_id' => $loginStatus->user_id,
                        'first_name' => $loginStatus->first_name,
                        'email' => $loginStatus->email,
                        'phone' => $loginStatus->phone,
                        'status' => $loginStatus->status,
                        'date_added' => $loginStatus->date_added,
                        'date_updated' => $loginStatus->date_updated,
                    ];
                    $responseData = array(
                        'status' => 'success',
                        'userInfo' => $patientDate,
                        //  'userInfo' => $userInfo,
                    );
                    return $this->response($responseData, 200);
                } else {
                    $input_data = array(
                        'first_name' => $this->input->post('first_name', true),
                        'email' => $this->input->post('email', true),
                        'status' => $status,
                        'date_added' => $date_added,
                        'date_updated' => $date_added,
                    );
                    $res = $this->User_model->insert($input_data);
                    $insert_id = $this->db->insert_id();
                    $query = $this->db->get_where('users', array('user_id' => $insert_id));
                    $row = $query->row();
                    if (!empty($this->input->post('language_id', true))) {
                        if ($res == true) {
                            $res = $this->Api_model->get_label_value('user_registered_successfully', $this->input->post('language_id', true));
                            $data['success_message'] = $res->label_element_value;
                        } else {
                            $res = $this->Api_model->get_label_value('unable_to_register_please_try_again', $this->input->post('language_id', true));
                            $data['error_message'] = $res->label_element_value;
                        }
                    } else {
                        if ($res == true) {
                            $data['success_message'] = 'User registered successfully';
                        } else {
                            $data['error_message'] = 'Unable to register, Please try again';
                        }
                    }

                    $responseData = array(
                        'status' => 'success',
                        'message' => $data['success_message'],
                        'userInfo' => array(
                            'user_id' => $row->user_id,
                            'first_name' => $row->first_name,
                            'email' => $row->email,
                            'phone' => $row->phone,
                            'status' => $row->status,
                            'date_added' => $row->date_added,
                            'date_updated' => $row->date_updated,
                        ),
                    );
                    return $this->response($responseData, 200);
                }
            } elseif ( null !== $this->input->post('phone') && !empty($this->input->post('phone'))) {
                $data = array('phone' => $this->input->post('phone'), 'status' => 1);
                $loginStatus = $this->Api_model->checkLogin($data);
                if ($loginStatus != false) {
                    $patientDate = [
                        'user_id' => $loginStatus->user_id,
                        'first_name' => $loginStatus->first_name,
                        'email' => $loginStatus->email,
                        'phone' => $loginStatus->phone,
                        'status' => $loginStatus->status,
                        'date_added' => $loginStatus->date_added,
                        'date_updated' => $loginStatus->date_updated,
                    ];
                    $responseData = array(
                        'status' => 'success',
                        'userInfo' => $patientDate,
                        //  'userInfo' => $userInfo,
                    );
                    return $this->response($responseData, 200);
                } else {
                    $input_data = array(
                        'first_name' => $this->input->post('first_name', true),
                        'phone' => $this->input->post('phone', true),
                        'status' => $status,
                        'date_added' => $date_added,
                        'date_updated' => $date_added,
                    );
                    $res = $this->User_model->insert($input_data);
                    $insert_id = $this->db->insert_id();
                    $query = $this->db->get_where('users', array('user_id' => $insert_id));
                    $row = $query->row();
                    if (!empty($this->input->post('language_id', true))) {
                        if ($res == true) {
                            $res = $this->Api_model->get_label_value('user_registered_successfully', $this->input->post('language_id', true));
                            $data['success_message'] = $res->label_element_value;
                        } else {
                            $res = $this->Api_model->get_label_value('unable_to_register_please_try_again', $this->input->post('language_id', true));
                            $data['error_message'] = $res->label_element_value;
                        }
                    } else {
                        if ($res == true) {
                            $data['success_message'] = 'User registered successfully';
                        } else {
                            $data['error_message'] = 'Unable to register, Please try again';
                        }
                    }

                    $responseData = array(
                        'status' => 'success',
                        'message' => $data['success_message'],
                        'userInfo' => array(
                            'user_id' => $row->user_id,
                            'first_name' => $row->first_name,
                            'email' => $row->email,
                            'phone' => $row->phone,
                            'status' => $row->status,
                            'date_added' => $row->date_added,
                            'date_updated' => $row->date_updated,
                        ),
                    );
                    return $this->response($responseData, 200);
                }
            } else {
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field', $this->input->post('language_id', true));
                    $responseData = array(
                        'status' => 'error',
                        'message' => $res->label_element_value
                    );
                } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Validation failed please check your input field',
                    );
                }
                return $this->response($responseData);
            }
        } else {
            if (!empty($this->input->post('language_id', true))) {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field', $this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }

    public function contact_us_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('user_id', 'User Name', 'required');
        $this->form_validation->set_rules('email_id', 'Password', 'required');
        $this->form_validation->set_rules('message', 'Password', 'required');
        if ($this->form_validation->run()) {
            $input_data = array(
                'user_id' => $this->input->post('user_id', true),
                'email_id' => $this->input->post('email_id', true),
                'message' => $this->input->post('message', true),
                'status' => $status,
                'date_added' => $date_added,
                'date_updated' => $date_added,
            );
            $res = $this->Api_model->insert_contact($input_data);
            if(!empty($this->input->post('language_id', true))){
                $res = $this->Api_model->get_label_value('message_is_successfully_submitted',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'success',
                    'message' => $res->label_element_value,
                );
                return $this->response($responseData);
            }
            else{
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Message is successfully submitted',
                );
                return $this->response($responseData);
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }

    public function login_post()
    {
        $email = $this->post('email');
        $password = $this->post('password');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            $data = array('email' => $email, 'password' => md5($password), 'status' => 1);
            $loginStatus = $this->Api_model->checkLogin($data);
            if ($loginStatus != false) {
                $patientDate = [
                    'user_id' => $loginStatus->user_id,
                    'first_name' => $loginStatus->first_name,
                    'email' => $loginStatus->email,
                    'phone' => $loginStatus->phone,
                    'status' => $loginStatus->status,
                    'date_added' => $loginStatus->date_added,
                    'date_updated' => $loginStatus->date_updated,
                ];
                $responseData = array(
                    'status' => 'success',
                    'userInfo' => $patientDate,
                    //  'userInfo' => $userInfo,
                );
                return $this->response($responseData, 200);
            } else {
                if(!empty($this->input->post('language_id', true))){
                    $res = $this->Api_model->get_label_value('email_does_not_exist',$this->input->post('language_id', true));
                    $responseData = array(
                        'status' => 'error',
                        'message' => $res->label_element_value,
                    );
                    return $this->response($responseData);
                }
                else{
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Email Does not exist',
                    );
                    return $this->response($responseData);
                }
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('invalid_email_or_password',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Email Or Password',
                );
            }
            return $this->response($responseData);
        }
    }
    public function forgotpw_post()
    {
        // $this->load->library('email');
        // $this->load->config('email');
        $this->load->library('form_validation');
        $this->load->helper('string');
        // echo random_string('alnum', 16);
        // die();
        $email = $this->post('email');
        $this->form_validation->set_rules('email', 'Email', 'required');
        if ($this->form_validation->run()) {
            $data = array('email' => $email);
            $loginStatus = $this->Api_model->checkForgotPW($data);
            if ($loginStatus != false) {
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('mail_sent', $this->input->post('language_id', true));
                    $responseData = array(
                        'status' => 'success',
                        'message' => $res->label_element_value
                    );
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Mail Sent',
                    );
                }
                return $this->response($responseData);

            } else {
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('email_not_found', $this->input->post('language_id', true));
                    $responseData = array(
                        'status' => 'error',
                        'message' => $res->label_element_value
                    );
                } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Email not found',
                    );
                }
                return $this->response($responseData);
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('invalid_email',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Email',
                );
            }
            return $this->response($responseData);
        }
    }
    public function load_profile_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
                'user_id' => form_error('user_id')
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_id = $this->input->post('user_id', true);
            $profile_data = $this->Api_model->load_profile_data($user_id);
            //$is_followed_by = $this->Api_model->load_profile_data($user_id);
            $this->load->helper('functions');
            //echo get_current_datetime();
            $responseData = array(
                'status' => 'success',
                'data' => $profile_data,
            );
            return $this->response($responseData, 200);
        }
    }
    public function manage_profile_post()
    {
        $user_id = $this->input->post('user_id', true);
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        $this->form_validation->set_rules('last_name', 'Last Name', 'required');
        $this->form_validation->set_rules('phone', 'Phone', 'required');
        $this->form_validation->set_rules('gender', 'gender', 'required');
        $this->form_validation->set_rules('email', 'email', 'required');
        $this->form_validation->set_rules('address', 'address', 'required');
        $this->form_validation->set_rules('state', 'state', 'required');
        $this->form_validation->set_rules('city', 'city', 'required');
        $this->form_validation->set_rules('dob', 'dob', 'required');
        $this->form_validation->set_rules('description', 'description', 'required');
        $this->form_validation->set_rules('zipcode', 'zipcode', 'required');

        if ($this->form_validation->run() == false) {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        } else //If validation success
        {
            $this->load->helper('functions');
            //echo get_current_datetime();
            $date_added = get_current_datetime();

            $input_data = array(
                'first_name' => $this->input->post('first_name', true),
                'last_name' => $this->input->post('last_name', true),
                'gender' => $this->input->post('gender', true),
                'email' => $this->input->post('email', true),
                'phone' => $this->input->post('phone', true),
                'address' => $this->input->post('address', true),
                'state' => $this->input->post('state', true),
                'city' => $this->input->post('city', true),
                'zipcode' => $this->input->post('zipcode', true),
                'dob' => $this->input->post('dob', true),
                'description' => $this->input->post('description', true),
                'date_updated' => $date_added,
            );
            $res = $this->User_model->update($input_data, $user_id);
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('profile_updated_successfully',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'success',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Profile Updated successfully',
                );
            }
            return $this->response($responseData);
        }
    }
    public function manage_profile_image_post()
    {
        $user_id = $this->input->post('user_id', true);
        //Form Validation
        $this->form_validation->set_rules('edit_id', 'edit id', 'required');
        if ($this->form_validation->run() == false) {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        } else //If validation success
        {
            $profile_data = $this->Api_model->load_profile_data($user_id);
            if (isset($profile_data[0]['profile_image'])) {
                $image_path = './media/profile_images/' . $profile_data[0]['profile_image'];
                if (file_exists($image_path)) {
                    unlink($image_path);
                }
            }
            $this->load->library('upload');
            if (!is_dir('./media/profile_images')) {
                mkdir('./media/profile_images');
            }
            $uploadPath = 'media/profile_images/';
            $config['upload_path'] = $uploadPath;
            $config['allowed_types'] = 'gif|jpg|png|jpeg';
            $config['encrypt_name'] = true;
            $this->upload->initialize($config);
            if (!$this->upload->do_upload('profile_image')) {
                if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('please_upload_a_image_in_this_format',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please upload a image in this format gif|jpg|png|jpeg'
                );
            }
            return $this->response($responseData);
            } else {
                $Profile_data = $this->upload->data();
                $profile_image_name = $Profile_data['file_name'];
                //Get Current Date and Time
                $this->load->helper('functions');
                //echo get_current_datetime();
                $date_added = get_current_datetime();
                $input_data = array(
                    'date_updated' => $date_added,
                    'profile_image' => $profile_image_name,
                );
                $res = $this->User_model->update($input_data, $user_id);
                if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('profile_image_updated_successfully',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'success',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Profile Image Updated successfully',
                );
            }
            return $this->response($responseData);
            }
        }
    }
    public function follow_unfollow_post()
    {
        $this->form_validation->set_rules('status', 'status', 'required');
        $this->form_validation->set_rules('from_user_id', 'from_user_id', 'required');
        $this->form_validation->set_rules('to_user_id', 'to_user_id', 'required');
        if ($this->form_validation->run() == false) {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        } else {
            $this->db->where('from_user_id', $this->input->post('from_user_id'));
            $this->db->where('to_user_id', $this->input->post('to_user_id'));
            $query = $this->db->get('follow_table');
            if ($query->num_rows() > 0) {
                // row exists
                $this->load->helper('functions');
                $date_added = get_current_datetime();
                $input_data = array(
                    'status' => $this->input->post('status'),
                    'date_updated' => $date_added,
                );
                $this->db->where('from_user_id', $this->input->post('from_user_id'));
                $this->db->where('to_user_id', $this->input->post('to_user_id'));
                $result = $this->db->update('follow_table', $input_data);

                if(!empty($this->input->post('language_id', true))){
                    if ($this->input->post('status') == 0) {
                        $res = $this->Api_model->get_label_value('unfollow_request_done',$this->input->post('language_id', true));
                        $responseData = array(
                            'status' => 'success',
                            'message' => $res->label_element_value,
                        );
                        return $this->response($responseData, 200);
                    } else {
                        $res = $this->Api_model->get_label_value('follow_request_done',$this->input->post('language_id', true));
                        $responseData = array(
                            'status' => 'success',
                            'message' => $res->label_element_value,
                        );
                        return $this->response($responseData, 200);
                    }
                }else{
                    if ($this->input->post('status') == 0) {
                        $responseData = array(
                            'status' => 'success',
                            'message' => 'Unfollow request done',
                        );
                        return $this->response($responseData, 200);
                    } else {
                        $responseData = array(
                            'status' => 'success',
                            'message' => 'Follow request done',
                        );
                        return $this->response($responseData, 200);
                    }
                }
                
            } else {
                // row does not exist
                $this->load->helper('functions');
                $date_added = get_current_datetime();
                $input_data = array(
                    'from_user_id' => $this->input->post('from_user_id'),
                    'to_user_id' => $this->input->post('to_user_id'),
                    'status' => $this->input->post('status'),
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('follow_table', $input_data);
                if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('follow_request_done',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'success',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Follow request done',
                );
            }
            return $this->response($responseData);
            }
        }
    }
    public function changepwd_post()
    {
        $user_id = $this->post('user_id');
        $old_password = $this->post('old_password');
        $new_password = $this->post('new_password');
        $this->form_validation->set_rules('user_id', 'user Id', 'required');
        $this->form_validation->set_rules('old_password', 'Old Password', 'required');
        $this->form_validation->set_rules('new_password', 'New Password', 'required');
        $date_added = date('Y-m-d H:i:s');
        if ($this->form_validation->run()) {
            $data = array('user_id' => $user_id, 'password' => md5($old_password));
            $loginStatus = $this->Api_model->change_password($data);
            if ($loginStatus != false) {
                $date = [
                    'password' => md5($new_password),
                    'date_updated' => $date_added,
                ];
                $this->Api_model->update_password($user_id, $date);
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('password_updated', $this->input->post('language_id', true));
                    $responseData = array(
                        'status' => 'success',
                        'message' => $res->label_element_value
                    );
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Password Updated',
                    );
                }
                return $this->response($responseData);
            } else {
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('invalid_old_password', $this->input->post('language_id', true));
                    $responseData = array(
                        'status' => 'error',
                        'message' => $res->label_element_value
                    );
                } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Invalid Old Password',
                    );
                }
                return $this->response($responseData);
            }
        } else {
            if (!empty($this->input->post('language_id', true))) {
                $res = $this->Api_model->get_label_value('invalid_password', $this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Password',
                );
            }
            return $this->response($responseData);
        }
    }
    public function abuse_post()
    {
        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('video_id', 'Video ID', 'required');
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('reason', 'reason', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('video_id', $this->input->post('video_id', true));
            $query = $this->db->get('abuse');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'reason' => $this->input->post('reason', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('video_id', $this->input->post('video_id', true));
                $result = $this->db->update('abuse', $input_data);
            } else {
                // Insert a new row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'reason' => $this->input->post('reason', true),
                    'status' => 1,
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('abuse', $input_data);
            }
            if ($result > 0) {
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('commented',$this->input->post('language_id', true));
                    $this->response([
                        'status' => 'success',
                        'message' => $res->label_element_value,
                    ], REST_Controller::HTTP_OK);
                }else {
                    $this->response([
                        'status' => 'success',
                        'message' => 'Commented',
                    ], REST_Controller::HTTP_OK);
                }
            } else {
                if (!empty($this->input->post('language_id', true))) {
                    $res = $this->Api_model->get_label_value('failed',$this->input->post('language_id', true));
                    $this->response([
                        'status' => 'error',
                        'message' => $res->label_element_value,
                    ], REST_Controller::HTTP_BAD_REQUEST);
                }else {
                    $this->response([
                        'status' => 'error',
                        'message' => 'Failed',
                    ], REST_Controller::HTTP_BAD_REQUEST);
                }
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }
    public function user_isfollowed_check_post()
    {
        $user_id = $this->post('user_id');
        $this->form_validation->set_rules('user_id', 'User Id', 'required');
        if ($this->form_validation->run()) {
            $result = $this->Api_model->load_profile($user_id);
            $date_value = $result->dob;
            $date = new DateTime($date_value);
            $formatted_date = $date->format('d F Y');
            if ($result[0]['profile_image'] == null || $result[0]['profile_image'] == '') {
                $profile_image = base_url() . 'media/profile_images/default.png';
            } else {
                $profile_image = base_url() . 'media/profile_images/' . $result[0]['profile_image'];
            }
            if ($result[0]['about_me'] == null) {
                $about_me = '';
            } else {
                $about_me = $result[0]['about_me'];
            }

            $myarray = array(
                'user_id' => $result[0]['user_id'],
                'user_name' => $result[0]['user_name'],
                'first_name' => $result[0]['first_name'],
                'last_name' => $result[0]['last_name'],
                'phone' => $result[0]['phone'],
                'dob' => $formatted_date,
                'email' => $result[0]['email'],
                'following' => $result[0]['following'],
                'followers' => $result[0]['followers'],
                'profile_image' => $profile_image,
                'aboutme' => $about_me
            );
            $responseData = array(
                'status' => 'success',
                'data' => $myarray,
            );
            return $this->response($responseData);
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }
    public function get_user_profile_post()
    {
        $user_id = $this->post('user_id');
        $check_id = $this->post('check_id');
        $this->form_validation->set_rules('user_id', 'User Id', 'required');
        if ($this->form_validation->run()) {
            if (isset($user_id) and empty($check_id)) {
                $result = $this->Api_model->load_profile($user_id);
                if ($result[0]['dob'] && !empty($result[0]['dob'])) {
                    $date_value = $result[0]['dob'];
                    $date = new DateTime($date_value);
                    $formatted_date = $date->format('d-m-Y');
                } else {
                    $formatted_date = '';
                }
                if ($result[0]['profile_image'] == null || $result[0]['profile_image'] == '') {
                    $profile_image = base_url() . 'media/profile_images/default.png';
                } else {
                    $profile_image = base_url() . 'media/profile_images/' . $result[0]['profile_image'];
                }
                if ($result[0]['about_me'] == null) {
                    $about_me = '';
                } else {
                    $about_me = $result[0]['about_me'];
                }

                $myarray = array(
                    'user_id' => $result[0]['user_id'],
                    'user_name' => $result[0]['user_name'],
                    'first_name' => $result[0]['first_name'],
                    'last_name' => $result[0]['last_name'],
                    'phone' => $result[0]['phone'],
                    'dob' => $formatted_date,
                    'email' => $result[0]['email'],
                    'following' => $result[0]['following'],
                    'followers' => $result[0]['followers'],
                    'profile_image' => $profile_image,
                    'aboutme' => $about_me
                );
                $responseData = array(
                    'status' => 'success',
                    'data' => $myarray,
                );
                return $this->response($responseData);
            } else {
                // //if user_id and check_id is set then call this api

                $result = $this->Api_model->load_profile($user_id);
                $isfollowed = $this->Api_model->checkFollowed($user_id, $check_id);

                $date_value = $result[0]['dob'];
                $date = new DateTime($date_value);
                $formatted_date = $date->format('d F Y');
                if ($result[0]['profile_image'] == null || $result[0]['profile_image'] == '') {
                    $profile_image = base_url() . 'media/profile_images/default.png';
                } else {
                    $profile_image = base_url() . 'media/profile_images/' . $result[0]['profile_image'];
                }
                if ($result[0]['about_me'] == null) {
                    $about_me = '';
                } else {
                    $about_me = $result[0]['about_me'];
                }
                $myarray = array(
                    'user_id' => $result[0]['user_id'],
                    'user_name' => $result[0]['user_name'],
                    'first_name' => $result[0]['first_name'],
                    'last_name' => $result[0]['last_name'],
                    'phone' => $result[0]['phone'],
                    'dob' => $formatted_date,
                    'email' => $result[0]['email'],
                    'following' => $result[0]['following'],
                    'followers' => $result[0]['followers'],
                    'isFollowed' => $isfollowed,
                    'profile_image' => $profile_image,
                    'aboutme' => $about_me
                );
                $responseData = array(
                    'status' => 'success',
                    'data' => $myarray,
                );
                return $this->response($responseData);
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }

    public function delete_account_post()
    {
        // change user status 
        $user_id = $this->input->post('user_id');
        $this->form_validation->set_rules('user_id', 'User Id', 'required');
        if ($this->form_validation->run()) {
            $res = $this->Api_model->delete_account($user_id);
            if ($res == true) {
                if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('account_deactivated',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'success',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Account Deactivated',
                );
            }
            return $this->response($responseData);
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Account Deactivated',
                );
                return $this->response($responseData);
            } else {
                if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('failed_to_deactivate_account',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Failed to deactivate account',
                );
            }
            return $this->response($responseData);
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }
    public function interest_list_get()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $interest_list = $this->Api_model->get_interests($get_data);

        foreach ($interest_list['interest_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($interest_list['interest_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function qualification_list_get()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $qualification_list = $this->Api_model->get_qualifications($get_data);

        foreach ($qualification_list['qualification_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($qualification_list['qualification_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function language_list_get()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $language_list = $this->Api_model->get_language($get_data);

        foreach ($language_list['language_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($language_list['language_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function city_list_post()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $state = $this->input->post('state_code');
        $city_list = $this->Api_model->get_cities($get_data, $state);

        foreach ($city_list['city_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($city_list['city_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function state_list_get()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $state_list = $this->Api_model->get_states($get_data);

        foreach ($state_list['state_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($state_list['state_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function authenticate_get()
    {
        $token = $this->generate_token(['name' => 'Aimsoft', 'password' => '3edc#EDC']);
        $this->output
            ->set_content_type('application/json')
            ->set_status_header(200)
            ->set_output(json_encode(['token' => $token]));
    }
    public function upload_images_post()
    {
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        } else {
            $this->load->helper('functions');
            $date_added = get_current_datetime();
            $count = count($_FILES['image']['name']);

            for ($i = 0; $i < $count; $i++) {

                if (!empty($_FILES['image']['name'][$i])) {

                    $_FILES['file']['name'] = $_FILES['image']['name'][$i];
                    $_FILES['file']['type'] = $_FILES['image']['type'][$i];
                    $_FILES['file']['tmp_name'] = $_FILES['image']['tmp_name'][$i];
                    $_FILES['file']['error'] = $_FILES['image']['error'][$i];
                    $_FILES['file']['size'] = $_FILES['image']['size'][$i];

                    $config['upload_path'] = 'media/user_images/';
                    $config['allowed_types'] = 'jpg|jpeg|png|gif';
                    $config['file_name'] = $_FILES['image']['name'][$i];

                    if($i == 0) {
                        $default_image = 1;
                    }else {
                        $default_image = 0;
                    }
                    $this->load->library('upload', $config);

                    if ($this->upload->do_upload('file')) {
                        $uploadData = $this->upload->data();
                        $filename = $uploadData['file_name'];

                        $input_data = array(
                            'user_id' => $this->input->post('user_id'),
                            'file_path' => $filename,
                            'default_image' => $default_image,
                            'status' => 1,
                            'date_added' => $date_added,
                            'date_updated' => $date_added,
                        );
                        $res = $this->db->insert('user_image', $input_data);
                    }
                }
            }
            if ($res == TRUE) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Image Uploaded successfully',
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please try again',
                );
            }
            return $this->response($responseData);
        }
    }
    public function select_default_image_post()
    {
        $user_id = $this->input->post('user_id', true);
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('image_index', 'index', 'required');

        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'error',
                'message' => 'Validation failed please check your input field',
            );

            return $this->response($responseData);
        } else //If validation success
        {
            $this->load->helper('functions');
            //echo get_current_datetime();
            $date_added = get_current_datetime();

            $images = $this->Api_model->get_post_images($user_id);
            foreach($images as $key => $item){
                if($key == $this->post('image_index'))
                {
                    $input_data = array(
                        'user_id' => $this->post('user_id'),
                        'default_image' => 1,
                        'date_updated' => $date_added
                    );
                    $this->db->set($input_data);
                    $this->db->where("user_image_id", $images[$key]['user_image_id']);
                    $res = $this->db->update("user_image", $input_data);
                }
                else
                {
                    $input_data = array(
                        'user_id' => $this->post('user_id'),
                        'default_image' => 0,
                    );
                    $this->db->set($input_data);
                    $this->db->where("user_image_id", $images[$key]['user_image_id']);
                    $res = $this->db->update("user_image", $input_data);
                }
            }
            if ($res == true) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Default selected',
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No results found',
                );
            }
            return $this->response($responseData);
        }
    }
    public function user_preference_post()
    {
        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('gender', 'gender', 'required');
        $this->form_validation->set_rules('seeing', 'seeing', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $query = $this->db->get('user_preference');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'user_id' => $this->input->post('user_id', true),
                    'full_name' => $this->input->post('full_name', true),
                    'gender' => $this->input->post('gender', true),
                    'birthday' => $this->input->post('birthday', true),
                    'email' => $this->input->post('email', true),
                    'qualification_id' => $this->input->post('qualification_id', true),
                    'seeing' => $this->input->post('seeing', true),
                    'city_id' => $this->input->post('city_id', true),
                    'state_code' => $this->input->post('state_code', true),
                    'distance' => $this->input->post('distance', true),
                    'status' => 1,
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->delete("known_language");
                $lang_list = $this->input->post('language', true);
                $array1 = json_decode($lang_list, true);
                foreach( $array1 as $language) {
                    $data = array(
                        'user_id' => $this->input->post('user_id', true),
                        'user_language_id' => $language,
                        'status' => 1,
                        'date_added' => $date_added,
                        'date_updated' => $date_added
                    );
                    $this->db->insert('known_language', $data);
                }
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->delete("user_interest");
                $int_list = $this->input->post('interest', true);
                $array2 = json_decode($int_list, true);
                foreach( $array2 as $interest) {
                    $data = array(
                        'user_id' => $this->input->post('user_id', true),
                        'interest_master_id' => $interest,
                        'status' => 1,
                        'date_added' => $date_added,
                        'date_updated' => $date_added
                    );
                    $this->db->insert('user_interest', $data);
                }
                $this->db->where('user_id', $this->input->post('user_id', true));
                $result = $this->db->update('user_preference', $input_data);
                if($result > 0){
                    $message = 'Updated Successfully';
                }else {
                    $message = 'Please try again';
                }
    
            } else {
                // Insert a new row
                $input_data = array(
                    'user_id' => $this->input->post('user_id', true),
                    'full_name' => $this->input->post('full_name', true),
                    'gender' => $this->input->post('gender', true),
                    'birthday' => $this->input->post('birthday', true),
                    'email' => $this->input->post('email', true),
                    'qualification_id' => $this->input->post('qualification_id', true),
                    'seeing' => $this->input->post('seeing', true),
                    'city_id' => $this->input->post('city_id', true),
                    'state_code' => $this->input->post('state_code', true),
                    'distance' => $this->input->post('distance', true),
                    'status' => 1,
                    'date_added' => $date_added,
                    'date_updated' => $date_added
                );
                $lang_list = $this->input->post('language', true);
                $array1 = json_decode($lang_list, true);
                foreach ($array1 as $language) {
                    $data = array(
                        'user_id' => $this->input->post('user_id', true),
                        'user_language_id' => $language,
                        'status' => 1,
                        'date_added' => $date_added,
                        'date_updated' => $date_added
                    );
                    $this->db->insert('known_language', $data);
                }
                $int_list = $this->input->post('interest', true);
                $array2 = json_decode($int_list, true);
                foreach ($array2 as $interest) {
                    $data = array(
                        'user_id' => $this->input->post('user_id', true),
                        'interest_master_id' => $interest,
                        'status' => 1,
                        'date_added' => $date_added,
                        'date_updated' => $date_added
                    );
                    $this->db->insert('user_interest', $data);
                }
                $result = $this->db->insert('user_preference', $input_data);
                $message = 'Added Successfully';
            }
            if ($result > 0) {
                    $this->response([
                        'status' => 'success',
                        'message' => $message,
                    ], REST_Controller::HTTP_OK);
            } else {
                    $this->response([
                        'status' => 'error',
                        'message' => 'Failed',
                    ], REST_Controller::HTTP_BAD_REQUEST);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function get_user_preference_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_id = $this->input->post('user_id', true);
            $post_list = $this->Api_model->get_user_preference($user_id);

            $this->load->library('datetime');
            $providedDateStr = $post_list['birthday'];
            $providedDate = DateTime::createFromFormat('d/m/Y', $providedDateStr);
            $currentDate = new DateTime();
            $interval = $currentDate->diff($providedDate);
            $years = $interval->y;
                $order = array(
                    'user_preference_id' => $post_list['user_preference_id'],
                    'user_id' => $post_list['user_id'],
                    'full_name' => $post_list['full_name'],
                    'gender' => $post_list['gender'],
                    'birthday' => $post_list['birthday'],
                    'age' => $years,
                    'email' => $post_list['email'],
                    'qualification_id' => $post_list['qualification_id'],
                    'qualification_name' => $post_list['qualification_name'],
                    'seeing' => $post_list['seeing'],
                    'city_id' => $post_list['city_id'],
                    'city' => $post_list['city'],
                    'state_code' => $post_list['state_code'],
                    'state' => $post_list['state'],
                    'distance' => $post_list['distance'],
                    'status' => $post_list['status'],
                    'post_images' => "",
                    'interest' => array(),
                    'language' => array()
                );
                $interest = $this->Api_model->get_interest($post_list['user_id']);
                if(!empty($interest)){
                    foreach ($interest as $item) {
                            $order['interest'][] = array(
                                'user_interest_id' => $item['user_interest_id'],
                                'user_id' => $item['user_id'],
                                'interest_master_id' => $item['interest_master_id'],
                                'interest_name' => $item['interest_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $languages = $this->Api_model->known_language($post_list['user_id']);
                if(!empty($languages)){
                    foreach ($languages as $item) {
                            $data['language'] = $item['language_name'];
                            $order['language'][] = array(
                                'known_language_id' => $item['known_language_id'],
                                'user_id' => $item['user_id'],
                                'user_language_id' => $item['user_language_id'],
                                'language_name' => $item['language_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $items = $this->Api_model->get_post_images($post_list['user_id']);
                if(!empty($items)){
                        if($items['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/user_images/'.$items['file_path'];
                            
                        }
                }

                // $newlist[] = $order;
            if (!empty($post_list)) {
    
                $responseData = array(
                    'status' => 'success',
                    'data'  => $order
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',
    
                );
                return $this->response($responseData);
            }
        }
    }
    public function postlist_post()
    {
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $user_id = $this->input->post('user_id');
            if(!empty($user_id)) {
                $data = array('user_id' => $user_id);
                $this->db->where($data);
                $query = $this->db->get('user_preference');
                $res = $query->row_array();
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Validation failed please check your input field',

                );
                return $this->response($responseData);
            }
            $material_list = $this->input->post('material_type');
            $array1 = json_decode($material_list, true);
            $search = array(
                'search_text' => $this->input->post('search_text'),
                'seeing' => $res['seeing'],
                'material_type' => $array1,
            );
            $orderList = $this->Api_model->get_post($get_data, $search);
            foreach ($orderList['user_list'] as $list) {
                $providedDateStr = $list['birthday'];
                $providedDate = DateTime::createFromFormat('d/m/Y', $providedDateStr);
                $currentDate = new DateTime();
                $interval = $currentDate->diff($providedDate);
                $years = $interval->y;
                if(!empty($user_id)) {
                    $data = array('user_id' => $user_id, 'user_preference_id' => $list['user_preference_id']);
                    $res = $this->Api_model->is_fav($data);
                    if ($res != false) {
                        if($res->status == 1) {
                            $fav = $res->status;
                        } else {
                            $fav = 0;
                        }
                    } else {
                        $fav = 0;
                    }
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Validation failed please check your input field',
    
                    );
                    return $this->response($responseData);
                }
                $order = array(
                    'user_preference_id' => $list['user_preference_id'],
                    'user_id' => $list['user_id'],
                    'full_name' => $list['full_name'],
                    'gender' => $list['gender'],
                    'age' => $years,
                    'email' => $list['email'],
                    'qualification_id' => $list['qualification_id'],
                    'qualification_name' => $list['qualification_name'],
                    'seeing' => $list['seeing'],
                    'city_id' => $list['city_id'],
                    'city' => $list['city'],
                    'state_code' => $list['state_code'],
                    'state' => $list['state'],
                    'distance' => $list['distance'],
                    'status' => $list['status'],
                    'is_favourite' => $fav,
                    'post_images' => "",
                    'interest' => array(),
                    'language' => array()
                );
                $interest = $this->Api_model->get_interest($list['user_id']);
                if(!empty($interest)){
                    foreach ($interest as $item) {
                            $order['interest'][] = array(
                                'user_interest_id' => $item['user_interest_id'],
                                'user_id' => $item['user_id'],
                                'interest_master_id' => $item['interest_master_id'],
                                'interest_name' => $item['interest_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $languages = $this->Api_model->known_language($list['user_id']);
                if(!empty($languages)){
                    foreach ($languages as $item) {
                            $data['language'] = $item['language_name'];
                            $order['language'][] = array(
                                'known_language_id' => $item['known_language_id'],
                                'user_id' => $item['user_id'],
                                'user_language_id' => $item['user_language_id'],
                                'language_name' => $item['language_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $items = $this->Api_model->get_post_images($list['user_id']);
                if(!empty($items)){
                        if($items['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/user_images/'.$items['file_path'];
                            
                        }
                }
            
                $newlist[] = $order;
            } 
            if (!empty($orderList['user_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
    }
    public function my_favourite_post()
    {
        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('user_preference_id', 'user_preference_id ', 'required');
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('status', 'status', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('user_preference_id', $this->input->post('user_preference_id', true));
            $query = $this->db->get('my_favourite');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'user_preference_id' => $this->input->post('user_preference_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'status' => $this->input->post('status', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('user_preference_id', $this->input->post('user_preference_id', true));
                $result = $this->db->update('my_favourite', $input_data);
                if($this->input->post('status', true) == 1){
                    $message = 'Added to Favourite';
                }else {
                    $message = 'Removed from Favourite';
                }
    
            } else {
                // Insert a new row
                $input_data = array(
                    'user_preference_id' => $this->input->post('user_preference_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'status' => $this->input->post('status', true),
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('my_favourite', $input_data);
                $message = 'Added to Favourite';
            }
            if ($result > 0) {
                    $this->response([
                        'status' => 'success',
                        'message' => $message,
                    ], REST_Controller::HTTP_OK);
            } else {
                    $this->response([
                        'status' => 'error',
                        'message' => 'Failed',
                    ], REST_Controller::HTTP_BAD_REQUEST);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function favouritelist_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $data = $this->input->post('user_id', true);
            $post_list = $this->Api_model->favouritelist_data($get_data, $data);
            foreach ($post_list['user_list'] as $list) {
                $providedDateStr = $list['birthday'];
                $providedDate = DateTime::createFromFormat('d/m/Y', $providedDateStr);
                $currentDate = new DateTime();
                $interval = $currentDate->diff($providedDate);
                $years = $interval->y;
                if(!empty($data)) {
                    $dataf = array('user_id' => $data, 'user_preference_id' => $list['user_preference_id']);
                    $res = $this->Api_model->is_fav($dataf);
                    if ($res != false) {
                        if($res->status == 1) {
                            $fav = $res->status;
                        } else {
                            $fav = 0;
                        }
                    } else {
                        $fav = 0;
                    }
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Validation failed please check your input field',
    
                    );
                    return $this->response($responseData);
                }
                $order = array(
                    'user_preference_id' => $list['user_preference_id'],
                    'user_id' => $list['user_id'],
                    'full_name' => $list['full_name'],
                    'gender' => $list['gender'],
                    'age' => $years,
                    'email' => $list['email'],
                    'qualification_id' => $list['qualification_id'],
                    'qualification_name' => $list['qualification_name'],
                    'seeing' => $list['seeing'],
                    'city_id' => $list['city_id'],
                    'city' => $list['city'],
                    'state_code' => $list['state_code'],
                    'state' => $list['state'],
                    'distance' => $list['distance'],
                    'status' => $list['status'],
                    'is_favourite' => $fav,
                    'post_images' => "",
                    'interest' => array(),
                    'language' => array()
                );
                $interest = $this->Api_model->get_interest($list['user_id']);
                if(!empty($interest)){
                    foreach ($interest as $item) {
                            $order['interest'][] = array(
                                'user_interest_id' => $item['user_interest_id'],
                                'user_id' => $item['user_id'],
                                'interest_master_id' => $item['interest_master_id'],
                                'interest_name' => $item['interest_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $languages = $this->Api_model->known_language($list['user_id']);
                if(!empty($languages)){
                    foreach ($languages as $item) {
                            $data['language'] = $item['language_name'];
                            $order['language'][] = array(
                                'known_language_id' => $item['known_language_id'],
                                'user_id' => $item['user_id'],
                                'user_language_id' => $item['user_language_id'],
                                'language_name' => $item['language_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $items = $this->Api_model->get_post_images($list['user_id']);
                if(!empty($items)){
                        if($items['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/user_images/'.$items['file_path'];
                            
                        }
                    }
            
                $newlist[] = $order;
            } 
            if (!empty($post_list['user_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
        }
    }
    public function send_message_post()
    {
        $this->form_validation->set_rules('user_id_from', 'user id', 'required');
        $this->form_validation->set_rules('user_id_to', 'user id', 'required');
        $this->form_validation->set_rules('message', 'message', 'required');

        $this->load->helper('functions');
        $date_added = get_current_datetime();

        if ($this->form_validation->run()) {
            $data = [
                'user_id_from' => $this->post('user_id_from'),
                'user_id_to' => $this->post('user_id_to'),
                'message' => $this->post('message'),
                'status' => 1,
                'date_added' => $date_added,
                'date_updated' => $date_added

            ];

            $res = $this->db->insert('message', $data);
            if ($res) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Message Sent',
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please try again',
                );
            }
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData);
        }
    }
    public function get_user_message_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_id = $this->input->post('user_id');
            $user_list = $this->Api_model->get_user_msg($user_id);
            // print_r($user_list);
            // die;
            if(!empty($user_list))
            {
                foreach ($user_list as $list) {
                    if($list['user_id_from'] == $user_id) {
                        $id_list = $list['user_id_to'];
                    } elseif($list['user_id_to'] == $user_id) {
                        $id_list = $list['user_id_from'];
                    }
                    $new_list[] = $id_list;
                }
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',

                );
                return $this->response($responseData);
            }
            $this->load->helper('array');
            $unique_array = array_unique($new_list);
            $unique_count = count($unique_array);
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $user_msg_list = $this->Api_model->get_user_list($get_data, $unique_array);
            
            foreach ($user_msg_list['user_list'] as $ulist) {
                $user['user_id'] = $ulist['user_id'];
                $user['full_name'] = $ulist['full_name'];
                $items = $this->Api_model->get_post_images($ulist['user_id']);
                if(!empty($items)){
                    $user['image_path'] = base_url() . 'media/user_images/'.$items['file_path'];
                }
                $new_ulist[] = $user;
            }
            if (!empty($user_msg_list['user_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'total_user' => $unique_count,
                    // 'image_url' => base_url().'media/profile_images/',
                    'data'  => $new_ulist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',

                );
                return $this->response($responseData);
            }
        }
    }
    public function get_message_list_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id_from', 'user id', 'required');
        $this->form_validation->set_rules('user_id_to', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $user_id_from = $this->input->post('user_id_from');
            $user_id_to = $this->input->post('user_id_to');
            $msg_list = $this->Api_model->get_msg_list($get_data, $user_id_from, $user_id_to);

            foreach ($msg_list['msg_list'] as $list) {
                $new_list[] = $list;
            }
            if (!empty($msg_list['msg_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'data'  => $new_list
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',

                );
                return $this->response($responseData);
            }
        }
    }
    public function search_users_post()
    {
        $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $search = array(
                'search_text' => $this->input->post('search_text'),
            );
            $orderList = $this->Api_model->get_users($get_data, $search);
            foreach ($orderList['user_list'] as $list) {
                $order = array(
                    'user_preference_id' => $list['user_preference_id'],
                    'user_id' => $list['user_id'],
                    'full_name' => $list['full_name'],
                    'post_images' => ""
                );
                $items = $this->Api_model->get_post_images($list['user_id']);
                if(!empty($items)){
                        if($items['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/user_images/'.$items['file_path'];
                            
                        }
                }
            
                $newlist[] = $order;
            } 
            if (!empty($orderList['user_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
    }
    public function user_details_post()
    {
            $user_id = $this->input->post('user_id');
            if(!empty($user_id)) {
                $data = array('user_id' => $user_id);
                $this->db->where($data);
                $query = $this->db->get('user_preference');
                $res = $query->row_array();
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Validation failed please check your input field',

                );
                return $this->response($responseData);
            }
            $orderList = $this->Api_model->user_details($user_id);
                $providedDateStr = $orderList['birthday'];
                $providedDate = DateTime::createFromFormat('d/m/Y', $providedDateStr);
                $currentDate = new DateTime();
                $interval = $currentDate->diff($providedDate);
                $years = $interval->y;
                if(!empty($user_id)) {
                    $data = array('user_id' => $user_id, 'user_preference_id' => $orderList['user_preference_id']);
                    $res = $this->Api_model->is_fav($data);
                    if ($res != false) {
                        if($res->status == 1) {
                            $fav = $res->status;
                        } else {
                            $fav = 0;
                        }
                    } else {
                        $fav = 0;
                    }
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Validation failed please check your input field',
    
                    );
                    return $this->response($responseData);
                }
                $order = array(
                    'user_preference_id' => $orderList['user_preference_id'],
                    'user_id' => $orderList['user_id'],
                    'full_name' => $orderList['full_name'],
                    'gender' => $orderList['gender'],
                    'age' => $years,
                    'email' => $orderList['email'],
                    'qualification_id' => $orderList['qualification_id'],
                    'qualification_name' => $orderList['qualification_name'],
                    'seeing' => $orderList['seeing'],
                    'city_id' => $orderList['city_id'],
                    'city' => $orderList['city'],
                    'state_code' => $orderList['state_code'],
                    'state' => $orderList['state'],
                    'distance' => $orderList['distance'],
                    'status' => $orderList['status'],
                    'is_favourite' => $fav,
                    'post_images' => "",
                    'interest' => array(),
                    'language' => array()
                );
                $interest = $this->Api_model->get_interest($orderList['user_id']);
                if(!empty($interest)){
                    foreach ($interest as $item) {
                            $order['interest'][] = array(
                                'user_interest_id' => $item['user_interest_id'],
                                'user_id' => $item['user_id'],
                                'interest_master_id' => $item['interest_master_id'],
                                'interest_name' => $item['interest_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $languages = $this->Api_model->known_language($orderList['user_id']);
                if(!empty($languages)){
                    foreach ($languages as $item) {
                            $data['language'] = $item['language_name'];
                            $order['language'][] = array(
                                'known_language_id' => $item['known_language_id'],
                                'user_id' => $item['user_id'],
                                'user_language_id' => $item['user_language_id'],
                                'language_name' => $item['language_name'],
                                'status' => $item['status'],
                                'date_added' => $item['date_added'],
                                'date_added' => $item['date_added'],
                            ); 
                    }
                }
                $items = $this->Api_model->get_post_images($orderList['user_id']);
                if(!empty($items)){
                        if($items['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/user_images/'.$items['file_path'];
                            
                        }
                }
            if (!empty($orderList)) {

                $responseData = array(
                    'status' => 'success',
                    'data'  => $order
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
    }
    public function suggested_profile_post()
    {
        $user_data = $this->input->get();
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $user_id = $this->input->post('user_id');

        if (empty($user_id)) {
            $responseData = array(
                'status' => 'error',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData);
        }

        $res = $this->Api_model->get_user_preference($user_id);

        if (empty($res)) {
            $responseData = array(
                'status' => 'error',
                'message' => 'No user preference found for the given user ID',
            );
            return $this->response($responseData);
        }

        $interest_arr = $this->Api_model->get_interest($user_id);
        $interest_arr_id = array_map(function ($arr1) {
            return $arr1['interest_master_id'];
        }, $interest_arr);

        sort($interest_arr_id);

        $search = array('seeing' => $res['seeing']);
        $orderList = $this->Api_model->get_suggested_profile($get_data, $search);

        $newlist = array();

        foreach ($orderList['user_list'] as $list) {
            if ($list['user_id'] == $user_id) {
                continue;
            }
            $user_interest_arr = $this->Api_model->get_interest($list['user_id']);
            $user_interest_arr_id = array_map(function ($arr2) {
                return $arr2['interest_master_id'];
            }, $user_interest_arr);

            sort($user_interest_arr_id);

            $i = $j = 0;
            $matched = false;

            while ($i < count($interest_arr_id) && $j < count($user_interest_arr_id)) {
                if ($interest_arr_id[$i] == $user_interest_arr_id[$j]) {
                    $matched = true;
                    break;
                } elseif ($interest_arr_id[$i] < $user_interest_arr_id[$j]) {
                    $i++;
                } else {
                    $j++;
                }
            }

            if ($matched) {
                $providedDateStr = $list['birthday'];
                $providedDate = DateTime::createFromFormat('d/m/Y', $providedDateStr);
                $currentDate = new DateTime();
                $interval = $currentDate->diff($providedDate);
                $years = $interval->y;

                $data = array('user_id' => $user_id, 'user_preference_id' => $list['user_preference_id']);
                $res = $this->Api_model->is_fav($data);
                if ($res != false) {
                    $fav = ($res->status == 1) ? 1 : 0;
                } else {
                    $fav = 0;
                }

                $order = array(
                    'user_preference_id' => $list['user_preference_id'],
                    'user_id' => $list['user_id'],
                    'full_name' => $list['full_name'],
                    'gender' => $list['gender'],
                    'age' => $years,
                    'email' => $list['email'],
                    'qualification_id' => $list['qualification_id'],
                    'qualification_name' => $list['qualification_name'],
                    'seeing' => $list['seeing'],
                    'city_id' => $list['city_id'],
                    'city' => $list['city'],
                    'state_code' => $list['state_code'],
                    'state' => $list['state'],
                    'distance' => $list['distance'],
                    'status' => $list['status'],
                    'is_favourite' => $fav,
                    'post_images' => "",
                    'interest' => array(),
                    'language' => array()
                );
                $interest = $this->Api_model->get_interest($list['user_id']);
                if (!empty($interest)) {
                    foreach ($interest as $item) {
                        $order['interest'][] = array(
                            'user_interest_id' => $item['user_interest_id'],
                            'user_id' => $item['user_id'],
                            'interest_master_id' => $item['interest_master_id'],
                            'interest_name' => $item['interest_name'],
                            'status' => $item['status'],
                            'date_added' => $item['date_added'],
                            'date_added' => $item['date_added'],
                        );
                    }
                }
                $languages = $this->Api_model->known_language($list['user_id']);
                if (!empty($languages)) {
                    foreach ($languages as $item) {
                        $data['language'] = $item['language_name'];
                        $order['language'][] = array(
                            'known_language_id' => $item['known_language_id'],
                            'user_id' => $item['user_id'],
                            'user_language_id' => $item['user_language_id'],
                            'language_name' => $item['language_name'],
                            'status' => $item['status'],
                            'date_added' => $item['date_added'],
                            'date_added' => $item['date_added'],
                        );
                    }
                }
                $items = $this->Api_model->get_post_images($list['user_id']);
                if (!empty($items)) {
                    if ($items['default_image'] == 1) {
                        $order['post_images'] = base_url() . 'media/user_images/' . $items['file_path'];
                    }
                }
                $newlist[] = $order;
            }
        }

        if (!empty($newlist)) {
            $responseData = array(
                'status' => 'success',
                'data'  => $newlist,
            );
        } else {
            $responseData = array(
                'status' => 'success',
                'message' => 'No Records found',
            );
        }

        return $this->response($responseData);
    }


    public function languages_get()
    {
        $languages = $this->Api_model->get_languages();
        foreach ($languages as $list) {

            $data['language_id'] = $list['language_id'];
            $data['language_name'] = $list['language_name'];
            $data['language_symbol'] = $list['language_symbol'];
            $data['status'] = $list['status'];
            if ($list['language_name'] === "English") {
                $data['json_file'] = base_url() . 'media/languages/english.json';
                $data['flag'] = 'https://th.bing.com/th/id/R.ba7e7cea7e34e688476bdf84ff262be8?rik=nnKAyuJp%2bjKP7A&riu=http%3a%2f%2f3.bp.blogspot.com%2f-xOdwZXgbK7o%2fUKlISA2SvPI%2fAAAAAAAAEd8%2fvE3MM_a0p08%2fs640%2fBig%2bBen%2band%2bthe%2bLondon%2bEye.jpg&ehk=P4aDd62xSuc%2b07WN1saz7sWAwfXG3bRD4UIY3v9R39o%3d&risl=&pid=ImgRaw&r=0';
            }
            if ($list['language_name'] === "Spanish") {
                $data['json_file'] = base_url() . 'media/languages/spanish.json';
                $data['flag'] = 'https://i.pinimg.com/736x/56/54/b1/5654b1d05e0ba996050d29f7feb82b39--monuments-barcelona.jpg';
            }
            $new_list[] = $data;
        }
        if (!empty($languages)) {
            $responseData = array(
                'status' => 'success',
                'languages' => $new_list,
            );
            return $this->response($responseData);
        } else {
            if (!empty($this->input->post('language_id', true))) {
                $res = $this->Api_model->get_label_value('no_languages_found', $this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Languages found',
                );
            }
            return $this->response($responseData);
        }
    }
    private function generate_token($data)
    {
        $payload = json_encode($data);
        $iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length('aes-256-cbc'));
        $encrypted_payload = openssl_encrypt($payload, 'aes-256-cbc', $this->secret_key, 0, $iv);
        $encrypted_token = base64_encode($encrypted_payload) . ':' . base64_encode($iv);
        return $encrypted_token;
    }
    private function verify_token($encrypted_token)
    {
        $token_parts = explode(':', $encrypted_token);
        if (count($token_parts) != 2) {
            return false;
        }
        $encrypted_payload = base64_decode($token_parts[0]);
        $iv = base64_decode($token_parts[1]);
        $payload = openssl_decrypt($encrypted_payload, 'aes-256-cbc', $this->secret_key, 0, $iv);
        if (!$payload) {
            return false;
        }
        $data = json_decode($payload);
        if (!$data) {
            return false;
        }
        return true;
    }
}
