<?php
defined('BASEPATH') or exit('No direct script access allowed');
require APPPATH . '/libraries/REST_Controller.php';
class Api extends REST_Controller
{

    private $secret_key = 'Aimsoft';

    public function __construct()
    {
        parent::__construct();
        $this->load->model('Api_model');
        $this->load->model('User_model');
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->model('Like_model');
        $this->load->model('Comment_model');
        $this->load->model('Video_model');
        $this->load->database();
        $this->load->library('email');
        $this->load->helper('string');
        $encrypted_token = $this->input->get_request_header('token');
        $authenticated = $this->verify_token($encrypted_token);
        if (!$authenticated) {
            $this->output
                ->set_content_type('application/json')
                ->set_status_header(401)
                ->set_output(json_encode(['error' => 'Unauthorized']));
            exit;
        }
    }

    public function register_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('user_name', 'User Name', 'required');
        $this->form_validation->set_rules('email', 'Password', 'required|valid_email|is_unique[users.email]');
        $this->form_validation->set_rules('password', 'Password', 'required');
        $this->form_validation->set_rules('confirm_Password', 'Password', 'required');

        if ($this->form_validation->run()) {
            $input_data = array(
                'user_name' => $this->input->post('user_name', true),
                'email' => $this->input->post('email', true),
                'password' => md5($this->input->post('password', true)),
                'status' => $status,
                'date_added' => $date_added,
                'date_updated' => $date_added,
            );
            $res = $this->User_model->insert($input_data);
            $insert_id = $this->db->insert_id();
            $query = $this->db->get_where('users', array('user_id' => $insert_id));
            $row = $query->row();
            if ($res == true) {
                $data['success_message'] = 'User registered successfully';
            } else {
                $data['error_message'] = 'Something went wrong';
            }

            $responseData = array(
                'status' => 'success',
                'message' => $data['success_message'],
                'userInfo' => array(
									'user_id' => $row->user_id,
									'user_name' => $row->user_name,
									'first_name' => $row->first_name,
									'last_name' => $row->last_name,
									'email' => $row->email,
									'phone' => $row->phone,
									'dob' => $row->dob,
									'status' => $row->status,
									'date_added' => $row->date_added,
									'date_updated' => $row->date_updated,
                ),
            );
            return $this->response($responseData, 200);

        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Please check one of the field you entered is wrong',

            );
            return $this->response($responseData);
        }

    }

    public function login_post()
    {
        $email = $this->post('email');
        $password = $this->post('password');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            $data = array('email' => $email, 'password' => md5($password));
            $loginStatus = $this->Api_model->checkLogin($data);
            if ($loginStatus != false) {

                $patientDate = [
                    'user_id' => $loginStatus->user_id,
                    'user_name' => $loginStatus->user_name,
                    'first_name' => $loginStatus->first_name,
                    'last_name' => $loginStatus->last_name,
                    'email' => $loginStatus->email,
                    'phone' => $loginStatus->phone,
                    'dob' => $loginStatus->dob,
                    'status' => $loginStatus->status,
                    'date_added' => $loginStatus->date_added,
                    'date_updated' => $loginStatus->date_updated,
                ];

                $responseData = array(
                    'status' => 'success',
                    'userInfo' => $patientDate,
                    //  'userInfo' => $userInfo,
                );
                return $this->response($responseData, 200);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Email Does not exist',

                );
                return $this->response($responseData);
            }
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Invalid Email Or Password',

            );
            return $this->response($responseData);
        }
    }

    public function forgotpw_post()
    {

        // $this->load->library('email');
        // $this->load->config('email');
        $this->load->library('form_validation');
        $this->load->helper('string');
        // echo random_string('alnum', 16);
        // die();
        $email = $this->post('email');
        $this->form_validation->set_rules('email', 'Email', 'required');

        if ($this->form_validation->run()) {
            $data = array('email' => $email);
            $loginStatus = $this->Api_model->checkForgotPW($data);
            if ($loginStatus != false) {

                $responseData = array(
                    'status' => 'success',
                    'message' => 'Mail Sent',

                );
                return $this->response($responseData, 200);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Email not found',

                );
                return $this->response($responseData);
            }
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Invalid Email',
            );
            return $this->response($responseData);
        }
    }
    public function manage_profile_post()
    {

        $user_id = $this->input->post('user_id', true);
        //Form Validation
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        $this->form_validation->set_rules('last_name', 'Last Name', 'required');
        $this->form_validation->set_rules('phone', 'Phone', 'required');
        $this->form_validation->set_rules('dob', 'DOB', 'required');
        $this->form_validation->set_rules('edit_id', 'edit id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
                'first_name' => form_error('first_name'),
                'last_name' => form_error('last_name'),
                'phone' => form_error('phone'),
                'dob' => form_error('dob'),
                'email' => form_error('email'),
                'edit_id' => form_error('edit_id'),
            );
            return $this->response($responseData, 200);

        } else //If validation success
        {

            $this->load->library('upload');
            if (!is_dir('./media/profile_images')) {
                mkdir('./media/profile_images');
            }
            $uploadPath = 'media/profile_images/';
            $config['upload_path'] = $uploadPath;
            $config['allowed_types'] = 'gif|jpg|png';
            $config['max_size'] = '50000';
            $config['encrypt_name'] = true;
            $this->upload->initialize($config);

            if (!$this->upload->do_upload('profile_image')) {

                $responseData = array(
                    'status' => 'fail',
                    'messsage ' => 'Please upload a image in this format gif|jpg|png',
                );
                return $this->response($responseData, 200);

            } else {

                $Profile_data = $this->upload->data();
                $profile_image_name = $Profile_data['file_name'];
                //Get Current Date and Time
                $this->load->helper('functions');
                //echo get_current_datetime();
                $date_added = get_current_datetime();
                $input_data = array(
                    'first_name' => $this->input->post('first_name', true),
                    'last_name' => $this->input->post('last_name', true),
                    'phone' => $this->input->post('phone', true),
                    'dob' => $this->input->post('dob', true),
                    'date_updated' => $date_added,
                    'profile_image' => $profile_image_name,
                );

                $res = $this->User_model->update($input_data, $user_id);
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Profile Updated successfully',
                );
                return $this->response($responseData, 200);
            }
            $this->load->helper('functions');
            //echo get_current_datetime();
            $date_added = get_current_datetime();
            $input_data = array(
                'first_name' => $this->input->post('first_name', true),
                'last_name' => $this->input->post('last_name', true),
                'phone' => $this->input->post('phone', true),
                'dob' => $this->input->post('dob', true),
                'date_updated' => $date_added,
            );
            $res = $this->User_model->update($input_data, $user_id);
            $responseData = array(
                'status' => 'success',
                'message' => 'Profile Updated successfully',
            );
            return $this->response($responseData, 200);
        }
    }
		public function follow_unfollow_post(){
				$this->form_validation->set_rules('status', 'status', 'required');
        $this->form_validation->set_rules('from_user_id', 'from_user_id', 'required');
        $this->form_validation->set_rules('to_user_id', 'to_user_id', 'required');
				if ($this->form_validation->run() == false) {
					$responseData = array(
							'status' => 'fail',
							'message' => form_error('from_user_id').form_error('to_user_id').form_error('to_user_id'),
					);
					return $this->response($responseData, 200);
			} else { 
				$this->db->where('from_user_id', $this->input->post('from_user_id'));
				$this->db->where('to_user_id', $this->input->post('to_user_id'));
				$query = $this->db->get('follow_table');
				if ($query->num_rows() > 0) {
				// row exists
				$this->load->helper('functions');
				$date_added = get_current_datetime();
				$input_data = array(
						'status' => $this->input->post('status'),
						'date_updated' => $date_added,
				);
				$this->db->where('from_user_id', $this->input->post('from_user_id'));
				$this->db->where('to_user_id', $this->input->post('to_user_id'));
				$result = $this->db->update('follow_table', $input_data);
				$responseData = array(
					'status' => 'success',
					'message' => 'Unfollow request done',
				);
				return $this->response($responseData, 200);
				} else {
				// row does not exist
				$this->load->helper('functions');
				$date_added = get_current_datetime();
				$input_data = array(
						'from_user_id' => $this->input->post('from_user_id'),
						'to_user_id' => $this->input->post('to_user_id'),
						'status' => $this->input->post('status'),
						'date_added' => $date_added,
						'date_updated' => $date_added,
				);
				$result = $this->db->insert('follow_table', $input_data);
				$responseData = array(
					'status' => 'success',
					'message' => 'follow request done',
				);
				return $this->response($responseData, 200);
				}
			}
		}

    public function upload_videos_post()
    {
				$edit_id = 0;
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
                'edit_id' => form_error('edit_id'),
            );
            return $this->response($responseData, 200);
        } else {
            if ($edit_id == 1) {

            } else {
                $this->load->library('upload');
                if (!is_dir('./media/videos')) {
                    mkdir('./media/videos');
                }
                $uploadPath = 'media/videos/';
                $config['upload_path'] = $uploadPath;
                $config['allowed_types'] = 'mp4|avi|wmv|mov';
                $config['max_size'] = '50000';
                $config['encrypt_name'] = true;
                $this->upload->initialize($config);

                if (!$this->upload->do_upload('videos_file')) {

                    $responseData = array(
                        'status' => 'fail',
                        'videos ' => 'Please upload a video file',
                    );
                    return $this->response($responseData, 200);

                } else {

                    $VideoData = $this->upload->data();
                    $VideoName = $VideoData['file_name'];
                    $status = $this->input->post('status');
                    if (empty($status) || $status == null || $status == "") {
                        $status = 1;
                    } else {
                        $status = 0;
                    }
                    $this->load->helper('functions');
                    $date_added = get_current_datetime();
                    $input_data = array(
                        'user_id' => $this->input->post('user_id'),
                        'video_file' => $VideoName,
                        'video_title' => $this->input->post('videos_title'),
                        'video_description' => $this->input->post('videos_description'),
                        'status' => $status,
                        'date_added' => $date_added,
                        'date_updated' => $date_added,
                    );
                    $res = $this->db->insert('upload_videos',$input_data);
                    $insert_id = $this->db->insert_id();
                    $query = $this->db->get_where('upload_videos', array('video_id' => $insert_id));
                    $row = $query->row();
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Videos Uploaded successfully',
                    );
                    return $this->response($responseData, 200);

                }
            }
        }
    }

    public function upload_music_post()
    {

        $this->form_validation->set_rules('edit_id', 'status', 'required');
        $this->form_validation->set_rules('user_id', 'user id', 'required');

        $edit_id = $this->input->post('edit_id');

        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
                'edit_id' => form_error('edit_id'),
            );
            return $this->response($responseData, 200);
        } else {
            if ($edit_id == 1) {

            } else {
                $this->load->library('upload');
                if (!is_dir('./media/music')) {
                    mkdir('./media/music');
                }
                $uploadPath = 'media/music/';
                $config['upload_path'] = $uploadPath;
                $config['allowed_types'] = 'wmv|mov|mp3';
                $config['max_size'] = '50000';
                $config['encrypt_name'] = true;
                $this->upload->initialize($config);

                if (!$this->upload->do_upload('music_file')) {

                    $responseData = array(
                        'status' => 'fail',
                        'videos ' => 'Please upload a music file',
                    );
                    return $this->response($responseData, 200);

                } else {

                    $VideoData = $this->upload->data();
                    // $mp3path = base_url() . 'media/musics/' . $VideoData['file_name'];
                    // $file_info = $this->getid3->analyze($file_path);
                    // print_r($file_info);
                    // die;

                    $VideoName = $VideoData['file_name'];
                    $status = $this->input->post('status');
                    if (empty($status) || $status == null || $status == "") {
                        $status = 1;
                    } else {
                        $status = 0;
                    }
                    $this->load->helper('functions');
                    $date_added = get_current_datetime();
                    $input_data = array(
                        'user_id' => $this->input->post('user_id'),
                        'music_file' => $VideoName,
                        'status' => $status,
                        'date_updated' => $date_added,
                    );
                    $res = $this->Api_model->insert_upload_music($input_data);
                    $insert_id = $this->db->insert_id();
                    $query = $this->db->get_where('upload_musics', array('music_id' => $insert_id));
                    $row = $query->row();
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Music Uploaded successfully',
                    );
                    return $this->response($responseData, 200);

                }
            }
        }

    }

    public function changePwd_post()
    {

        $user_id = $this->post('user_id');
        $old_password = $this->post('old_password');
        $new_password = $this->post('new_password');

        $this->form_validation->set_rules('user_id', 'Patient Id', 'required');
        $this->form_validation->set_rules('old_password', 'Old Password', 'required');
        $this->form_validation->set_rules('new_password', 'New Password', 'required');

        $date_added = date('Y-m-d H:i:s');

        if ($this->form_validation->run()) {
            $data = array('user_id' => $user_id, 'password' => md5($old_password));
            $loginStatus = $this->Api_model->change_password($data);

            if ($loginStatus != false) {

                $date = [
                    'password' => md5($new_password),
                    'date_updated' => $date_added,
                ];
                $this->Api_model->update_password($user_id, $date);

                $responseData = array(
                    'status' => 'success',
                    'message' => 'Password Updated',
                    //  'userInfo' => $userInfo,
                );
                return $this->response($responseData, 200);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Old Password',

                );
                return $this->response($responseData);
            }
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Invalid Password',

            );
            return $this->response($responseData);
        }
    }
    public function like_post()
    {

        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('video_id', 'Video ID', 'required');
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('status', 'Status', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('video_id', $this->input->post('video_id', true));
            $query = $this->db->get('likes');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'status' => $this->input->post('status', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('video_id', $this->input->post('video_id', true));
                $result = $this->db->update('likes', $input_data);
            } else {
                // Insert a new row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'status' => $this->input->post('status', true),
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('likes', $input_data);
            }

            $likes = $this->Like_model->count_likes($this->input->post('video_id', true));
            if ($result > 0) {
                $this->response([
                    'status' => 'success',
                    'message' => 'Liked',
                    'likes' => $likes,

                ], REST_Controller::HTTP_OK);
            } else {

                $this->response([
                    'status' => 'error',
                    'message' => 'Failed',
                ], REST_Controller::HTTP_BAD_REQUEST);
            }

        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Please check one of the field you entered is wrong',

            );
            return $this->response($responseData);
        }

    }

    public function comment_post()
    {

        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('video_id', 'Video ID', 'required');
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('comment', 'Comment', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('video_id', $this->input->post('video_id', true));
            $query = $this->db->get('comments');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'comment' => $this->input->post('comment', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('video_id', $this->input->post('video_id', true));
                $result = $this->db->update('comments', $input_data);
            } else {
                // Insert a new row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'comment' => $this->input->post('comment', true),
                    'status' => 1,
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('comments', $input_data);
            }
            $comments = $this->Comment_model->count_comments($this->input->post('video_id', true));

            if ($result > 0) {
                $this->response([
                    'status' => 'success',
                    'message' => 'Commented',
                    'comments' => $comments,

                ], REST_Controller::HTTP_OK);
            } else {

                $this->response([
                    'status' => 'error',
                    'message' => 'Failed',
                ], REST_Controller::HTTP_BAD_REQUEST);
            }

        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Please check one of the field you entered is wrong',

            );
            return $this->response($responseData);
        }

    }
		public function abuse_post()
    {
    	  $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('video_id', 'Video ID', 'required');
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('reason', 'reason', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('video_id', $this->input->post('video_id', true));
            $query = $this->db->get('abuse');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'reason' => $this->input->post('reason', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('video_id', $this->input->post('video_id', true));
                $result = $this->db->update('abuse', $input_data);
            } else {
                // Insert a new row
                $input_data = array(
                    'video_id' => $this->input->post('video_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'reason' => $this->input->post('reason', true),
                    'status' => 1,
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('abuse', $input_data);
            }

            if ($result > 0) {
                $this->response([
                    'status' => 'success',
                    'message' => 'Commented',
                ], REST_Controller::HTTP_OK);
            } else {

                $this->response([
                    'status' => 'error',
                    'message' => 'Failed',
                ], REST_Controller::HTTP_BAD_REQUEST);
            }

        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Please check one of the field you entered is wrong',

            );
            return $this->response($responseData);
        }

    }
		
    public function commentlist_post()
    {

        $video_id = $this->post('video_id');
        $this->form_validation->set_rules('video_id', 'Video Id', 'required');

        if ($this->form_validation->run()) {
            // $data = array('video_id' => $video_id);
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $commentList = $this->Api_model->getComments($video_id, $get_data);
            // print_r( $commentList); die();
            foreach ($commentList['comments_list'] as $list) {
								$current_time = new DateTime('now');
								$datetime_obj = new DateTime($list['time']);
								$interval = $datetime_obj->diff($current_time);
								if ($interval->y > 0) {
									$data['time'] = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
								} elseif ($interval->m > 0) {
									$data['time']= $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
								} elseif ($interval->d > 0) {
								$data['time'] = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
								} elseif ($interval->h > 0) {
								$data['time'] = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
								} elseif ($interval->i > 0) {
								$data['time'] = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
								} else {
								$data['time'] = 'just now';
								}
                $data['user_id'] = $list['user_id'];
                $data['first_name']= $list['first_name'];
                $data['last_name']= $list['last_name'];                
                $data['comment_id']= $list['comment_id'];
                $data['comment']= $list['comment'];
                if($list['profile_image']==null){
                    $data['profile_image']= base_url().'/media/users/default.png';
                }
                else{
                    $data['profile_image']=base_url().'/media/users/'.$list['profile_image'];
                } 
               

                $new_list[] = $data;
            }
            if (!empty($commentList['comments_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'data' => $new_list,
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Invalid Video ID',

            );
            return $this->response($responseData);
        }
    }

    public function videolist_post()
    {
        $user_id = $this->post('user_id');

        $this->form_validation->set_rules('user_id', 'User Id', 'required');

        if ($this->form_validation->run()) {
            // $data = array('video_id' => $video_id);
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $videoList = $this->Api_model->getVideos();
            // print_r( $videoList); die();
            foreach ($videoList['videos_list'] as $list) {

                $data['video_id'] = $list['video_id'];
                $data['video_title'] = $list['video_title'];
                $data['video_file'] = $list['video_file'];
                $data['video_description'] = $list['video_description'];
								$current_time = new DateTime('now');
								$datetime_obj = new DateTime($list['time']);
								$interval = $datetime_obj->diff($current_time);
								if ($interval->y > 0) {
									$data['time'] = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
								} elseif ($interval->m > 0) {
									$data['time']= $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
								} elseif ($interval->d > 0) {
								$data['time'] = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
								} elseif ($interval->h > 0) {
								$data['time'] = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
								} elseif ($interval->i > 0) {
								$data['time'] = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
								} else {
								$data['time'] = 'just now';
								}
                $data['user_id'] = $list['user_id'];
                $data['user_name'] = $list['user_name'];
                $data['first_name'] = $list['first_name'];
                $data['last_name'] = $list['last_name'];
                $data['likes'] = $this->Like_model->count_likes($list['video_id']);
                $data['comments'] = $this->Comment_model->count_comments($list['video_id']);
                $check = $this->Api_model->is_liked($list['video_id'], $user_id);
                $data['isLiked'] = $check[0]['status'];
                $new_list[] = $data;
            }

            if (!empty($videoList['videos_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'base_url' => base_url() . 'media/videos/',
                    'data' => $new_list,
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',
                );
                return $this->response($responseData);
            }
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Invalid User ID',

            );
            return $this->response($responseData);
        }
    }
    public function authenticate_get()
    {
        $token = $this->generate_token(['name' => 'Aimsoft', 'password' => '3edc#EDC']);
        $this->output
            ->set_content_type('application/json')
            ->set_status_header(200)
            ->set_output(json_encode(['token' => $token]));
    }
    public function musiclist_get()
    {

			$user_data = $_GET;
			$get_data['counts_per_page'] = $user_data['counts_per_page'];
			$get_data['current_page'] = $user_data['current_page'];

        $musicList = $this->Api_model->get_music($get_data);
				$newlist = $musicList;
        if (!empty($musicList)) {
            $responseData = array(

                'status' => 'success',
                'base_url' => base_url() . 'media/music/',
                'data' => $newlist,
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Records found',
            );
            return $this->response($responseData);
        }
    }
    private function generate_token($data)
    {
        $payload = json_encode($data);
        $iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length('aes-256-cbc'));
        $encrypted_payload = openssl_encrypt($payload, 'aes-256-cbc', $this->secret_key, 0, $iv);
        $encrypted_token = base64_encode($encrypted_payload) . ':' . base64_encode($iv);
        return $encrypted_token;
    }

    private function verify_token($encrypted_token)
    {
        $token_parts = explode(':', $encrypted_token);
        if (count($token_parts) != 2) {
            return false;
        }
        $encrypted_payload = base64_decode($token_parts[0]);
        $iv = base64_decode($token_parts[1]);
        $payload = openssl_decrypt($encrypted_payload, 'aes-256-cbc', $this->secret_key, 0, $iv);
        if (!$payload) {
            return false;
        }
        $data = json_decode($payload);
        if (!$data) {
            return false;
        }
        return true;
    }
}
