<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Label extends CI_Controller {

	function __construct() { 
         parent::__construct(); 
         error_reporting(0);
		 $this->load->model('Label_model');	
    }
	
	public function index()
	{
		$this->get_listdata();
	}
	
	public function get_listdata()
	{
		$data['page_title'] = 'Labels';
		$this->load->view('admin/label_view',$data);
	}

	public function getdata($id)
	{
		$result = $this->Label_model->get_data($id); 
		echo json_encode($result);
	}
	
	public function add() { 
		$edit_id = $this->input->post('edit_id', TRUE);
		//echo "<br>ID:$edit_id";
		//Redirect if NAN
		if (!is_numeric($edit_id)) 
			$this->get_listdata();
		
		//Form Validation 
		$this->form_validation->set_rules('label_name', 'Label Name', 'required');
		 
		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
//			redirect('master/'.$type);
			$this->get_listdata();
		}
		else //If validation success
		{

			 $status =$this->input->post('status');
			 if(empty($status) || $status == NULL || $status == "") $status = 0;
			 else $status = 1;

			 $admin_user_id	= $this->session->userdata['logged_in']['admin_user_id'];
			//Get Current Date and Time
			$this->load->helper('functions');
			$date_added = get_current_datetime();

			
			
			if($edit_id==0) //Add
			{
				
				$input_data = array( 
					'label_name' => $this->input->post('label_name', TRUE),
					'admin_user_id' => $admin_user_id,
					'status' => $status,
					'date_added' => $date_added,
					'date_updated' => $date_added
				); 
				$res = $this->Label_model->insert($input_data); 
				
				if($res==true)$data['success_message'] = 'Record added successfully';else $data['error_message'] = 'Something went wrong';
				
			}
			else //Edit
			{
				$input_data = array( 
					'label_name' => $this->input->post('label_name', TRUE),
					'admin_user_id' => $admin_user_id,
					'status' => $status,
					'date_updated' => $date_added
				);
				$res = $this->Label_model->update($input_data,$edit_id);
				if($res==true)$data['success_message'] = 'Record updated successfully';else $data['error_message'] = 'Something went wrong';
			}
			//$this->get_listdata();
			$this->session->set_userdata('display_message', $data);
			redirect('label');
		}
	}
	public function upload_image($filename, $thumb_filename)
    {
        $config['upload_path']		= "images/";
        $config['allowed_types']    = "jpeg|jpg|png";
        $config['file_name']		= $filename;
        // return false;
        // die;
        $this->load->library('upload', $config);
        if ( ! $this->upload->do_upload('image'))
        {
            $this->session->set_flashdata('error', $this->upload->display_errors());
            // echo $this->upload->display_errors()."<br/>";
        	return false;
        }
        else
        {
			resizeImage($config['upload_path'] . $config['file_name'],  $config['upload_path']. $thumb_filename, 125, 125);
         	return true;
        }
    }
		 
	public function delete($id)
	{
		 $res = $this->Label_model->delete($id); 
		 if($res)
		 {
			 $data['success_message'] = 'Record delete successfully';
			 $this->session->set_userdata('display_message', $data);
		 }
		 else
		 {
			 $data['error_message'] = 'Something went wrong';
			 $this->session->set_userdata('display_message', $data);
		 }
		redirect('label');
		 
	}
	 
	
	public function setstatus()
	{
		$id = $this->input->post('id');
		$current_st = $this->input->post('current_st');
		if($current_st == 1) {
			$statusData = array('status' => 0);
		} else {
			$statusData = array('status' => 1);
		}
		$update = $this->Label_model->update_status($id, $statusData);
		if($update==true)
		{
			echo 1;
		}else{
			echo 0;
		}
	}
	
	public function get_list()
	{
		$list = $this->Label_model->get_datatables(); 
		$data = array();
		$no = $_POST['start'];
		foreach ($list as $r) {
			$primary_id = $r->label_id;
			$no++;
			$row = array();
			$row[] = '<input type="checkbox" name="chk[]" id="chk_'.$primary_id.'" value="'.$primary_id.'" />';
 			// $row[] = $no;
			$row[] = $r->label_name;
			 
			// if($r->date_updated=='0000-00-00 00:00:00'){
            //     $row[] = '';
            // }else{
            //     $row[] = $r->date_updated;
            // }
			if($r->status==1)
			{
				$status = "<label class='label label-success'>Active</label>";
			}else{
				$status = "<label class='label label-danger'>Inactive</label>";
			}
			$row[] = $status;
			
			$row[] = ' 
                         <span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="doEdit('. $primary_id.');" class="btn btn-dark btn-xs" data-toggle="modal" data-target="#model_add"> <i class="fa fa-pencil"></i></a>
                         <span class="tooltiptext">Edit</span>
                        </span>
                         <span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="DeleteSet('.$primary_id.');" class="btn btn-danger btn-xs" data-toggle="modal" data-target="#model_delete"> <i class="fa fa-trash-o"></i></a>
                         <span class="tooltiptext">Delete</span>
                        </span>
						';		
			$data[] = $row;
		}
		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->Label_model->count_all(),
						"recordsFiltered" => $this->Label_model->count_filtered(),
						"data" => $data
				);
		//output to json format
		echo json_encode($output);
	}
		  
}
?>

