<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Label_element extends CI_Controller {

	function __construct() { 
         parent::__construct(); 
         error_reporting(0);
		 $this->load->model('Label_element_model');	
    }
	
	public function index()
	{
		$this->get_listdata();
	}
	
	public function get_listdata()
	{
		$data['page_title'] = 'Labels Element';
		$data['language'] = $this->Label_element_model->getLanguage(); 
		$data['label'] = $this->Label_element_model->getLabel();
		$this->load->view('admin/label_element_view',$data);
	}

	public function getdata($id)
	{
		$result = $this->Label_element_model->get_data($id); 
		echo json_encode($result);
	}
	
	public function add() { 
		$edit_id = $this->input->post('edit_id', TRUE);
		//echo "<br>ID:$edit_id";
		//Redirect if NAN
		if (!is_numeric($edit_id)) 
			$this->get_listdata();
		
		//Form Validation 
		$this->form_validation->set_rules('language_id', 'Language', 'required');
		$this->form_validation->set_rules('label_id', 'Label', 'required');
		$this->form_validation->set_rules('label_element_value', 'Label Element', 'required');
		 
		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
//			redirect('master/'.$type);
			$this->get_listdata();
		}
		else //If validation success
		{

			 $status =$this->input->post('status');
			 if(empty($status) || $status == NULL || $status == "") $status = 0;
			 else $status = 1;

			 $admin_user_id	= $this->session->userdata['logged_in']['admin_user_id'];
			//Get Current Date and Time
			$this->load->helper('functions');
			$date_added = get_current_datetime();

			
			
			if($edit_id==0) //Add
			{
				
				$input_data = array( 
					'language_id' => $this->input->post('language_id', TRUE),
					'label_id' => $this->input->post('label_id', TRUE),
					'label_element_value' => $this->input->post('label_element_value', TRUE),
					'admin_user_id' => $admin_user_id,
					'status' => 1,
					'date_added' => $date_added,
					'date_updated' => $date_added
				); 
				$res = $this->Label_element_model->insert($input_data); 

				$this->languages($this->input->post('language_id', TRUE));
				
				if($res==true)$data['success_message'] = 'Record added successfully';else $data['error_message'] = 'Something went wrong';
				
			}
			else //Edit
			{
				$input_data = array( 
					'language_id' => $this->input->post('language_id', TRUE),
					'label_id' => $this->input->post('label_id', TRUE),
					'label_element_value' => $this->input->post('label_element_value', TRUE),
					'admin_user_id' => $admin_user_id,
					'status' => 1,
					'date_updated' => $date_added
				);
				$res = $this->Label_element_model->update($input_data,$edit_id);

				$this->languages($this->input->post('language_id', TRUE));

				if($res==true)$data['success_message'] = 'Record updated successfully';else $data['error_message'] = 'Something went wrong';
			}
			//$this->get_listdata();
			$this->session->set_userdata('display_message', $data);
			redirect('label_element');
		}
	}
		 
	public function delete($id)
	{
		 $res = $this->Label_element_model->delete($id); 
		 if($res)
		 {
			 $data['success_message'] = 'Record delete successfully';
			 $this->session->set_userdata('display_message', $data);
		 }
		 else
		 {
			 $data['error_message'] = 'Something went wrong';
			 $this->session->set_userdata('display_message', $data);
		 }
		redirect('label_element');
		 
	}
	 
	
	public function setstatus()
	{
		$id = $this->input->post('id');
		$current_st = $this->input->post('current_st');
		if($current_st == 1) {
			$statusData = array('status' => 0);
		} else {
			$statusData = array('status' => 1);
		}
		$update = $this->Label_element_model->update_status($id, $statusData);
		if($update==true)
		{
			echo 1;
		}else{
			echo 0;
		}
	}
	
	public function get_list()
	{
		$list = $this->Label_element_model->get_datatables(); 
		$data = array();
		$no = $_POST['start'];
		foreach ($list as $r) {
			$primary_id = $r->label_element_id;
			$no++;
			$row = array();
			// $row[] = '<input type="checkbox" name="chk[]" id="chk_'.$primary_id.'" value="'.$primary_id.'" />';
 			// $row[] = $no;
			$row[] = $r->language_name;
			$row[] = $r->label_name;
			$row[] = $r->label_element_value; 
			// if($r->date_updated=='0000-00-00 00:00:00'){
            //     $row[] = '';
            // }else{
            //     $row[] = $r->date_updated;
            // }
			// if($r->status==1)
			// {
			// 	$status = "<label class='label label-success'>Active</label>";
			// }else{
			// 	$status = "<label class='label label-danger'>Inactive</label>";
			// }
			// $row[] = $status;
			
			$row[] = ' 
                         <span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="doEdit('. $primary_id.');" class="btn btn-dark btn-xs" data-toggle="modal" data-target="#model_add"> <i class="fa fa-pencil"></i></a>
                         <span class="tooltiptext">Edit</span>
                        </span>
                         <span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="DeleteSet('.$primary_id.');" class="btn btn-danger btn-xs" data-toggle="modal" data-target="#model_delete"> <i class="fa fa-trash-o"></i></a>
                         <span class="tooltiptext">Delete</span>
                        </span>
						';		
			$data[] = $row;
		}
		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->Label_element_model->count_all(),
						"recordsFiltered" => $this->Label_element_model->count_filtered(),
						"data" => $data
				);
		//output to json format
		echo json_encode($output);
	}

	public function languages($language_id) {
		$data = $this->Label_element_model->get_language($language_id);
		$language = $this->Label_element_model->get_language_name($language_id);
		foreach ($data as $row) {
			$list[$row->label_name] = $row->label_element_value;
		}
		$lowercaseStr = strtolower($language->language_name);
		$filePath = FCPATH . 'media/languages/'.$lowercaseStr.'.json';
		$jsonData = json_encode($list, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
		if (file_put_contents($filePath, $jsonData)) {
			return true;
		} else {
			return false;
		}
        
	}

	public function labels() 
	{
		$this->load->helper('functions');
		$date_added = get_current_datetime();
		// Retrieve the input string
		$inputString = "user_registered_successfully, unable_to_register_please_try_again, validation_errors, validation_failed_please_check_your_input_field, message_is_successfully_submitted, please_check_one_of_the_field_you_entered_is_wrong, email_does_not_exist, invalid_email_or_password, mail_sent, email_not_found, invalid_email, profile_updated_successfully, please_upload_a_image_in_this_format, profile_image_updated_successfully, unfollow_request_done, follow_request_done, please_upload_a_video_file, videos_uploaded_successfully, please_upload_a_music_file, music_uploaded_successfully, password_updated, invalid_old_password, invalid_password, liked, unliked, failed, commented, year, month, day, hour, minute, ago, just_now, no_records_found, invalid_video_id, account_deactivated, failed_to_deactivate_account, no_languages_found";

		// Explode the string into an array
		$valuesArray = explode(", ", $inputString);
		$n = 87;
		// Iterate over the array and process each value
		foreach ($valuesArray as $value) {
			$input_data = array( 
				'label_name' => $value,
				'admin_user_id' => 1,
				'status' => 1,
				'date_added' => $date_added,
				'date_updated' => $date_added
			); 
			// Store each value in the database using CodeIgniter's database library or ORM
			$this->db->insert('label', $input_data);
			echo $n."<br>";
			$n++;
		}
	}
		  
}
?>

