<?php
//session_start();
Class Abuse_model extends CI_Model
{
	var $table = 'abuse';
	//var $table2 = 'customer_family';
	var $column_order = array('c.date_added, c.reason','c.status','c.date_updated');
	//set column field database for datatable orderable
	var $column_search = array('c.date_added, c.reason','c.status','c.date_updated');
	//set column field database for datatable searchable
	//var $order = array('full_name' => 'asc'); // default order
    
  	function __construct() {
	 	parent::__construct();
  	} 
	
	public function get_data($id) {
		$this->db->select('*');
		$this->db->from('abuse as a');
		$this->db->where('abuse_id', $id);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function get_list()
	{
		$this->db->select('*');
		$this->db->from('abuse');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function insert($data) { 

		 return $this->db->insert("abuse", $data);

	} 

    public function count_comments($v_id)
    {
        $this->db->where('video_id',$v_id);
        $this->db->where('status',1);
        $this->db->from("comments");
        return $this->db->count_all_results();
    }
	
	public function update($data,$id) { 
		$this->db->set($data); 
		$this->db->where("abuse_id", $id); 
		
		if ( $this->db->update("abuse", $data)) {  
		 return true; 
		}else{
		 return false;
		}
	} 
	
	public function delete($id) { 
		$this->db->where('abuse_id', $id);
		if ($this->db->delete("abuse")) { 
			return true; 
		}else{
			 return false;
		}
	} 

	public function update_status($id, $statusData) {
		$arrIds = explode(",",$id);
		$this->db->where_in('abuse_id', $arrIds);
		$update = $this->db->update('abuse', $statusData);
		return ($update==true)?true:false;
	}
	
	private function _get_datatables_query()
	{
		$this->db->select('c.date_added, c.reason, c.status, c.date_updated, u.first_name, u.last_name, v.video_file, v.video_title, v.video_description');
		$this->db->from('abuse as c');
		$this->db->join('upload_videos as v', 'v.video_id = c.video_id', 'left');
		$this->db->join('users as u', 'u.user_id = c.user_id','left');
		$i = 0;
		
		foreach ($this->column_search as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND.
					

					$this->db->like($item, $_POST['search']['value']);

					
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}
				if(count($this->column_search) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($this->column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}
	public function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		$query = $this->db->get();
		// echo "SQL:" . $this->db->last_query();
		return $query->result();
	}
	public function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}
	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

}
?>