<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Api_model extends CI_Model
{

  public function __construct()
  {
    parent::__construct();
    $this->load->database();
  }
  // ########login data Start-#####
  public function checkLogin($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  //#########-login data--end-##########

  public function change_password($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }

  public function update_password($user_id, $data)
  {
    $this->db->set($data);
    $this->db->where("user_id", $user_id);

    if ($this->db->update("users", $data)) {
      return true;
    } else {
      return false;
    }
  }

  // ################ Forgot Password start ##############

  public function checkForgotPW($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  // ################ Forgot Password end ###############

  public function checkFollowed($user_id,$check_id){
    $this->db->select('*');
    $this->db->from('follow_table');
    $this->db->where('follow_table.from_user_id',$check_id);
    $this->db->where('follow_table.to_user_id',$user_id);
    $this->db->where('follow_table.status', 1);
    $query = $this->db->get();
    if ($query->num_rows() > 0) {
        return true;
    } else {
        return false;
    }
  }

  public function load_profile($user_id)
  {
    $this->db->select('users.*, COUNT(DISTINCT CASE WHEN follow_table.status = 1 AND follow_table.from_user_id = users.user_id THEN follow_table.follow_table_id END) AS following, COUNT(DISTINCT CASE WHEN follow_table.status = 1 AND follow_table.to_user_id = users.user_id THEN follow_table.follow_table_id END) AS followers');
    $this->db->from('users');
    $this->db->join('follow_table', 'users.user_id = follow_table.to_user_id OR users.user_id = follow_table.from_user_id', 'left');
    $this->db->where('users.user_id', $user_id);
    $this->db->group_by('users.user_id');
    return $this->db->get()->result_array();
  }
  public function load_profile_check($to_user_id,$from_user_id)
  {
    //this query is running on phpmyadmin in xampp only but not working in live server
      $sql = 'SELECT users.*, 
              COUNT(DISTINCT CASE WHEN follow_table.status = 1 AND follow_table.from_user_id = users.user_id THEN follow_table.follow_table_id END) AS following, 
              COUNT(DISTINCT CASE WHEN follow_table.status = 1 AND follow_table.to_user_id = users.user_id THEN follow_table.follow_table_id END) AS followers, 
              CASE WHEN (follow_table.status = 1 AND follow_table.from_user_id = ? AND follow_table.to_user_id = ?) THEN TRUE ELSE FALSE END AS isFollowed
              FROM users
              LEFT JOIN follow_table ON users.user_id = follow_table.to_user_id OR users.user_id = follow_table.from_user_id
              WHERE users.user_id = ?
              GROUP BY users.user_id';
      $query = $this->db->query($sql, array($to_user_id,$from_user_id,$to_user_id));
      return $query->result_array();
  }


  public function delete_account($id) { 
    $data = array('status' => 0); // Set the new value for the status column
    $this->db->where("user_id", $id); 
    if ($this->db->update("users", $data)) {  
        return true; 
    } else {
        return false;
    }
}

  public function insert_contact($data) { 
    //echo "<br> Insert";
    if ($this->db->insert("contact_us", $data)) { 
    return true; 
    }else{
    return false;
    }
} 

  public function load_profile_data($user_id){
    //
    $this->db->select('*');
    $this->db->from('users');
    $this->db->where('user_id', $user_id);
    return $this->db->get()->result_array();
  }

  public function is_liked($v_id, $u_id) {
    $this->db->where('video_id', $v_id);
    $this->db->where('user_id', $u_id);
    $query = $this->db->get('likes');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return 0;
    }
  }
  public function get_interests($inputs)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $interests = $this->db->count_all_results('interest_master');
    $this->db->select('*');
    $this->db->from('interest_master');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $interests;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['interest_list'] = $result;
      }
    } else {
      $new_details['interest_list'] = $result;
    }
    return $new_details;
  }
  public function get_qualifications($inputs)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $qualifications = $this->db->count_all_results('qualification');
    $this->db->select('*');
    $this->db->from('qualification');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $qualifications;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['qualification_list'] = $result;
      }
    } else {
      $new_details['qualification_list'] = $result;
    }
    return $new_details;
  }
  public function get_language($inputs)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $languages = $this->db->count_all_results('user_language');
    $this->db->select('*');
    $this->db->from('user_language');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $languages;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['language_list'] = $result;
      }
    } else {
      $new_details['language_list'] = $result;
    }
    return $new_details;
  }
  public function get_cities($inputs, $state)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $cities = $this->db->where('state_code', $state)->count_all_results('cities');
    $this->db->select('*');
    $this->db->from('cities');
    $this->db->where('state_code', $state);

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $cities;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['city_list'] = $result;
      }
    } else {
      $new_details['city_list'] = $result;
    }
    return $new_details;
  }
  public function get_states($inputs)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $states = $this->db->count_all_results('states');
    $this->db->select('*');
    $this->db->from('states');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $states;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['state_list'] = $result;
      }
    } else {
      $new_details['state_list'] = $result;
    }
    return $new_details;
  }
  public function get_languages()
  {
    $this->db->select('*');
    $this->db->from('languages');
    $result = $this->db->get()->result_array();
    return $result;
  }
  public function get_label_value($label_name,$language_id)
	{
		$this->db->select('le.label_element_value, l.label_name, lg.language_name');
		$this->db->where('le.language_id', $language_id);
		$this->db->where('l.label_name', $label_name);
		$this->db->from('label_element as le');
		$this->db->join('label as l', 'l.label_id = le.label_id', 'left');
		$this->db->join('languages as lg ', 'lg.language_id = le.language_id', 'left');
		$query = $this->db->get();
		return $query->row();
	}
  public function get_post_images($id)
  {
    $this->db->select('*');
		$this->db->from('user_image');
		$this->db->where('user_id', $id);
    $this->db->where('default_image', 1);
		$query = $this->db->get();
		return $query->row_array();
  }
  public function get_user_preference($user_id)
  {
    $this->db->select('u.*,q.qualification_id,q.qualification_name,c.city_id,c.city,s.state_code,s.state');
    $this->db->from('user_preference as u');
    $this->db->where('user_id', $user_id);
    $this->db->join('qualification as q', 'q.qualification_id = u.qualification_id', 'left');
    $this->db->join('cities as c', 'c.city_id = u.city_id', 'left');
    $this->db->join('states as s', 's.state_code = u.state_code', 'left');
    $result = $this->db->get()->row_array();
    return $result;
  }
  public function get_interest($user_id)
  {
    $this->db->select('u.*, i.interest_name');
    $this->db->from('user_interest as u');
    $this->db->where('user_id', $user_id);
    $this->db->join('interest_master as i', 'i.interest_master_id = u.interest_master_id', 'left');
    $result = $this->db->get()->result_array();
    return $result;
  }
  public function known_language($user_id)
  {
    $this->db->select('k.*, u.language_name');
    $this->db->from('known_language as k');
    $this->db->where('user_id', $user_id);
    $this->db->join('user_language as u', 'u.user_language_id = k.user_language_id', 'left');
    $result = $this->db->get()->result_array();
    return $result;
  }
  public function get_post($inputs, $search)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $likeCondition = '';
    if (isset($search['search_text']) && !empty($search['search_text'])) {
      $search_text = $search['search_text'];
      $likeCondition .= "(p.title LIKE '%$search_text%') OR ";
      $likeCondition .= "(p.description LIKE '%$search_text%') OR ";
      $likeCondition .= "(p.location LIKE '%$search_text%') OR ";
      $likeCondition .= "(p.material_name LIKE '%$search_text%') OR ";
    }
    if (isset($search['seeing']) && !empty($search['seeing'])) {
      $seeing = $search['seeing'];
      $likeCondition .= "(p.gender LIKE '%$seeing%') OR ";
    }
    if (isset($search['material_type']) && !empty($search['material_type'])) {
      $material_type = $search['material_type'];
      $material_types_str = "'" . implode("', '", $material_type) . "'";
      $likeCondition .= "(p.material_type IN ($material_types_str)) OR ";
    }
    $likeCondition = rtrim($likeCondition, " OR ");

    $preferences = $this->db->count_all_results('user_preference', FALSE, FALSE, $likeCondition);
    $this->db->distinct('p.user_preference_id');
    $this->db->select('p.*, u.first_name,q.qualification_id,q.qualification_name,c.city_id,c.city,s.state_code,s.state');
    $this->db->from('user_preference as p');
    $this->db->where('p.status', 1);

		if(!empty($search['search_text'])){
			$this->db->like('p.title', $search['search_text']); 
			$this->db->or_like('p.description', $search['search_text']); 
			$this->db->or_like('p.location', $search['search_text']); 
			$this->db->or_like('p.material_name', $search['search_text']); 
		}
    if(!empty($search['seeing'])){
			$this->db->like('p.gender', $search['seeing']); 
		}
    if(!empty($search['material_type'])){
			$this->db->where_in('p.material_type', $search['material_type']);
		}
    $this->db->join('users as u', 'u.user_id = p.user_id', 'left');
    $this->db->join('qualification as q', 'q.qualification_id = p.qualification_id', 'left');
    $this->db->join('cities as c', 'c.city_id = p.city_id', 'left');
    $this->db->join('states as s', 's.state_code = p.state_code', 'left');
    $this->db->order_by('p.distance', 'ASC');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }

    $result = $this->db->get()->result_array();
    $count = $preferences;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['user_list'] = $result;
      }
    } else {
      $new_details['user_list'] = $result;
    }
    return $new_details;
  }
  public function is_fav($data)
  {
    $this->db->where($data);
    $query = $this->db->get('my_favourite');
    
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  public function favouritelist_data($inputs, $data)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $posts = $this->db->where('user_id',$data)->count_all_results('my_favourite');
    $this->db->select('m.date_updated as time, p.*, q.qualification_id,q.qualification_name,c.city_id,c.city,s.state_code,s.state');
    $this->db->from('my_favourite as m');
    $this->db->where('m.user_id', $data);
    $this->db->where('m.status', 1);
    $this->db->join('user_preference as p', 'p.user_preference_id = m.user_preference_id', 'left');
    $this->db->join('qualification as q', 'q.qualification_id = p.qualification_id', 'left');
    $this->db->join('cities as c', 'c.city_id = p.city_id', 'left');
    $this->db->join('states as s', 's.state_code = p.state_code', 'left');
    $this->db->order_by('m.date_updated', 'DESC');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $posts;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['user_list'] = $result;
      }
    } else {
      $new_details['user_list'] = $result;
    }
    return $new_details;
  }
  public function get_msg_list($inputs, $user_id_from, $user_id_to)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $where = "(`user_id_from` = $user_id_from AND `user_id_to` = $user_id_to) OR (`user_id_from` = $user_id_to AND `user_id_to` = $user_id_from)";
    $messages = $this->db->where($where)->count_all_results('message');
    $this->db->select('*');
    $this->db->from('message');
    $this->db->where('(user_id_from = ' . $user_id_from . ' AND user_id_to = ' . $user_id_to . ') OR (user_id_from = ' . $user_id_to . ' AND user_id_to = ' . $user_id_from . ')');
    $this->db->order_by('date_added', 'ASC');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $messages;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['msg_list'] = $result;
      }
    } else {
      $new_details['msg_list'] = $result;
    }
    return $new_details;
  }
  public function get_user_msg($user_id)
  {
    $messages = $this->db->where('user_id_from', $user_id)->count_all_results('message');
    $this->db->select('*');
    $this->db->from('message');
    $this->db->where('(user_id_from = ' . $user_id . ' OR user_id_to = ' . $user_id . ')');
    $this->db->order_by('date_added', 'DESC');

    $result = $this->db->get()->result_array();
    return $result;
  }
  public function get_user_list($inputs, $unique_array)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $users = $this->db->where_in('user_id', $unique_array)->count_all_results('users');
    $this->db->select('user_id, full_name');
    $this->db->from('user_preference');
    $this->db->where_in('user_id', $unique_array);

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $users;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['user_list'] = $result;
      }
    } else {
      $new_details['user_list'] = $result;
    }
    return $new_details;
  }
  public function get_users($inputs, $search)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $likeCondition = '';
    if (isset($search['search_text']) && !empty($search['search_text'])) {
      $search_text = $search['search_text'];
      $likeCondition .= "(p.full_name LIKE '%$search_text%') OR ";
    }
    $likeCondition = rtrim($likeCondition, " OR ");

    $preferences = $this->db->count_all_results('user_preference', FALSE, FALSE, $likeCondition);
    $this->db->distinct('p.user_preference_id');
    $this->db->select('p.*');
    $this->db->from('user_preference as p');
    $this->db->where('p.status', 1);

		if(!empty($search['search_text'])){
			$this->db->like('p.full_name', $search['search_text']); 
		}
    $this->db->join('users as u', 'u.user_id = p.user_id', 'left');
    $this->db->order_by('p.full_name', 'ASC');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }

    $result = $this->db->get()->result_array();
    $count = $preferences;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['user_list'] = $result;
      }
    } else {
      $new_details['user_list'] = $result;
    }
    return $new_details;
  }
  public function user_details($user_id)
  {
    $this->db->select('p.*,q.qualification_id,q.qualification_name,c.city_id,c.city,s.state_code,s.state');
    $this->db->from('user_preference as p');
    $this->db->where('p.status', 1);
		$this->db->where('p.user_id', $user_id);
    $this->db->join('qualification as q', 'q.qualification_id = p.qualification_id', 'left');
    $this->db->join('cities as c', 'c.city_id = p.city_id', 'left');
    $this->db->join('states as s', 's.state_code = p.state_code', 'left');
		$query = $this->db->get();
		return $query->row_array();
  }
  public function get_suggested_profile($inputs, $search)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $likeCondition = '';
    if (isset($search['seeing']) && !empty($search['seeing'])) {
      $seeing = $search['seeing'];
      $likeCondition .= "(p.gender LIKE '%$seeing%') OR ";
    }
    $likeCondition = rtrim($likeCondition, " OR ");

    $preferences = $this->db->count_all_results('user_preference', FALSE, FALSE, $likeCondition);
    $this->db->distinct('p.user_preference_id');
    $this->db->select('p.*, u.first_name,q.qualification_id,q.qualification_name,c.city_id,c.city,s.state_code,s.state');
    $this->db->from('user_preference as p');
    $this->db->where('p.status', 1);

    if(!empty($search['seeing'])){
			$this->db->like('p.gender', $search['seeing']); 
		}
    $this->db->join('users as u', 'u.user_id = p.user_id', 'left');
    $this->db->join('qualification as q', 'q.qualification_id = p.qualification_id', 'left');
    $this->db->join('cities as c', 'c.city_id = p.city_id', 'left');
    $this->db->join('states as s', 's.state_code = p.state_code', 'left');
    $this->db->order_by('p.distance', 'ASC');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }

    $result = $this->db->get()->result_array();
    $count = $preferences;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['user_list'] = $result;
      }
    } else {
      $new_details['user_list'] = $result;
    }
    return $new_details;
  }
}