<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Api_model extends CI_Model
{

  public function __construct()
  {
    parent::__construct();
    $this->load->database();
  }
  // ########login data Start-#####
  public function checkLogin($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  //#########-login data--end-##########

  public function change_password($data)
  {
    $this->db->where($data);
    $query = $this->db->get('patients');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }

  public function update_password($user_id, $data)
  {
    $this->db->set($data);
    $this->db->where("user_id", $user_id);

    if ($this->db->update("users", $data)) {
      return true;
    } else {
      return false;
    }
  }

  // ################ Forgot Password start ##############

  public function checkForgotPW($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  // ################ Forgot Password end ###############


  public function getComments($video_id, $inputs)
  {
    // $data = array('message_from_id' => $video_id, 'message_to_id' => $video_id);

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $comments = $this->db->where('video_id', $video_id)->count_all_results('comments');
    $this->db->select("c.comment_id, c.comment, c.date_added as time, u.user_id, u.first_name, u.last_name");
    $this->db->from('comments c');
    $this->db->where('c.video_id', $video_id);
    $this->db->join('users u', 'c.user_id = u.user_id', 'INNER');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }

    $result = $this->db->get()->result_array();
    // echo $this->db->last_query(); die();
    $count = $comments;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['comments_list'] = $result;
      }
    } else {
      $new_details['comments_list'] = $result;
    }
    return $new_details;
  }

  public function getVideos(){
    // $data = array('message_from_id' => $video_id, 'message_to_id' => $video_id);

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $comments = $this->db->count_all_results('upload_videos');
    $this->db->select("v.video_id, v.video_title, v.video_file, v.video_description, v.date_added as time, u.user_id, u.user_name, u.first_name, u.last_name");
    $this->db->from('upload_videos v');
    $this->db->join('users u', 'u.user_id = v.user_id','LEFT');
    $this->db->order_by("v.date_added", "desc");

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }

    $result = $this->db->get()->result_array();
    // echo $this->db->last_query(); die();
    $count = $comments;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['videos_list'] = $result;
      }
    } else {
      $new_details['videos_list'] = $result;
    }
    return $new_details;
  }

  public function is_liked($v_id, $u_id){
    $this->db->select("status");
    $this->db->from('likes');
    $this->db->where('video_id', $v_id);
    $this->db->where('user_id', $u_id);
    return $this->db->get()->result_array();
  }

  public function get_music($inputs){

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $musics = $this->db->count_all_results('upload_musics');
    $this->db->select('*');
    $this->db->from('upload_musics');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    $result = $this->db->get()->result_array();
    // echo $this->db->last_query(); die();
    $count = $musics;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['music_list'] = $result;
      }
    } else {
      $new_details['music_list'] = $result;
    }
    //here just change $result to $new_details for pagination
    return $result;
  } 
  }
}