<?php
//session_start();
Class Label_element_model extends CI_Model
{
	var $table = 'label_element';
	//var $table2 = 'customer_family';
	var $column_order = array('lg.language_name', 'lb.label_name', 'le.label_element_value'); //set column field database for datatable orderable
	var $column_search = array('lg.language_name', 'lb.label_name', 'le.label_element_value'); 
	//set column field database for datatable searchable 
	//	var $order = array('full_name' => 'asc'); // default order 
	
  	function __construct() { 
	 	parent::__construct(); 
  	} 
	
	public function get_data($id) {
		$this->db->select('*');
		$this->db->from('label_element as a');
		$this->db->where('label_element_id', $id);
		$query = $this->db->get();
		return $query->row();
	}

	public function getLanguage(){
		$response = array();     
        $this->db->select('*');
        $q = $this->db->get('languages');
        $response = $q->result_array();
        return $response;
	 }

	 public function getLabel(){

		$response = array();     
        $this->db->select('*');
        $q = $this->db->get('label');
        $response = $q->result_array();
        return $response;
	 }
	
	public function get_list()
	{
		$this->db->select('*');
		$this->db->from('label_element');
		$query = $this->db->get();
		return $query->result();
	}

	public function get_language($language_id)
	{
		$this->db->select('le.label_element_value, l.label_name, lg.language_name');
		$this->db->where('le.language_id', $language_id);
		$this->db->from('label_element as le');
		$this->db->join('label as l', 'l.label_id = le.label_id', 'left');
		$this->db->join('languages as lg ', 'lg.language_id = le.language_id', 'left');
		$query = $this->db->get();
		return $query->result();
	}
	public function get_language_name($language_id)
	{
		$this->db->select('*');
		$this->db->where('language_id', $language_id);
		$this->db->from('languages');
		$query = $this->db->get();
		return $query->row();
	}
	
	public function insert($data) { 
	    //echo "<br> Insert";
		 
		if ($this->db->insert("label_element", $data)) { 
			return true; 
		}else{
		 	return false;
		}
	} 
	
	public function update($data,$id) { 
		$this->db->set($data); 
		$this->db->where("label_element_id", $id); 
		
		if ( $this->db->update("label_element", $data)) {  
		 return true; 
		}else{
		 return false;
		}
	} 
	
	public function delete($id) { 
		$this->db->where('label_element_id', $id);
		if ($this->db->delete("label_element")) { 
			return true; 
		}else{
			 return false;
		}
	} 

	public function update_status($id, $statusData) {
		$arrIds = explode(",",$id);
		$this->db->where_in('label_element_id', $arrIds);
		$update = $this->db->update('label_element', $statusData);
		return ($update==true)?true:false;
	}
	
	private function _get_datatables_query()
	{
		// $this->db->select('*');
		// $this->db->from('label_element');
		$this->db->select('le.label_element_id, le.label_element_value, lg.language_id, lg.language_name, lb.label_id, lb.label_name');
			// $this->db->where('os.admin_user_id', $admin_user_id);
			$this->db->from('label_element as le');
			$this->db->join('languages as lg ', 'lg.language_id = le.language_id', 'left');
			$this->db->join('label as lb', 'lb.label_id = le.label_id', 'left'); 
		$i = 0;
	
		foreach ($this->column_search as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND.
					$this->db->like($item, $_POST['search']['value']);
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}
				if(count($this->column_search) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($this->column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}
	public function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		
		$query = $this->db->get();
		//echo "SQL:" . $this->db->last_query();
		return $query->result();
	}
	public function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}
	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

}
?>